#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = 998244353, N = 207;

int dp[N][N];

int mul(int a, int b) {
    return a * b % mod;
}

int fp(int a, int p) {
    int ans = 1, c = a;
    for (int i = 0; (1ll << i) <= p; ++i) {
        if ((p >> i) & 1) {
            ans = mul(ans, c);
        }
        c = mul(c, c);
    }
    return ans;
}

int inv(int a) {
    return fp(a, mod - 2);
}

void add(int &a, int b) {
    a += b;
    while (a >= mod) {
        a -= mod;
    }
}

int iv[N];
int C(int n, int k) {
    int ans = 1;
    for (int i = 0; i < k; ++i) {
        ans = mul(ans, n - i);
        ans = mul(ans, iv[i + 1]);
    }
    return ans;
}
int comb[N][N];
#define app push_back
void ckmax(int &a, int b) {
    a = max(a, b);
}
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int t;
    cin >> t;
    auto slv = [&] (int n, int m, vector <string> a) {
        vector <int> up(n + 1), down(n + 1);
        vector <vector <int> > pref(n, vector <int> (m + 1)), suf(n, vector <int> (m + 1));
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == '.') {
                    cur++;
                }
                else {
                    cur = 0;
                }
                pref[i][j + 1] = max(pref[i][j], cur);
            }
            cur = 0;
            for (int j = m - 1; j >= 0; --j) {
                if (a[i][j] == '.') {
                    cur++;
                }
                else {
                    cur = 0;
                }
                suf[i][j] = max(suf[i][j + 1], cur);
            }
        }
        for (int i = 0; i < n; ++i) {
            up[i + 1] = max(up[i], pref[i][m]);

        }
        for (int i = n - 1; i >= 0; --i) {
            down[i] = max(down[i + 1], pref[i][m]);
        }
        vector <int> lens;
        int ans = 0;
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                if (a[i][j] == '.'&&(i==0||a[i-1][j]!='.')) {
                    int u = i;
                    int maxpref = 0, maxsuf = 0;
                    while (u < n && a[u][j] == '.') {
                        ckmax(maxpref, pref[u][j]);
                        ckmax(maxsuf, suf[u][j + 1]);
                        u++;
                    }
                    ckmax(ans, u - i + up[i]);
                    ckmax(ans, u - i + down[u]);
                    ckmax(ans, u - i + maxpref);
                    ckmax(ans, u - i + maxsuf);
                    //cout << i << ' ' << j << ' ' << u << ' ' << pref[i][j] << ' ' << suf[i][j + 1] << endl;
                    lens.app(u - i);
                }
            }
        }
        sort(lens.begin(), lens.end());
        reverse(lens.begin(), lens.end());
        if (lens.size() >= 2) {
            ckmax(ans, lens[0] + lens[1]);
        }
        return ans;
    };
    for (int test= 0; test < t; ++test) {
        int n, m;
        cin >> n >> m;
        vector <string> a(n), b(m);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                b[j] += a[i][j];
            }
        }
        cout << max(slv(n, m, a), slv(m, n, b)) << endl;
    }
    return 0;
}
