#include <iostream>
#define int long long

using namespace std;

const int M = 998244353, N = 1007;
char a[N][N];

void init() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            a[i][j] = '.';
        }
    }
}

signed main() {
    init();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int ans = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (a[i][j] == '?') {
                int r = j;
                while (a[i][r] == '?')
                    r++;
                if (a[i][r] == '#' && a[i][j - 1] == '#') {
                    cout << 0 << endl;
                    return 0;
                }
                if (a[i][r] == '.' && a[i][j - 1] == '.') {
                    ans = (ans * (r - j + 1)) % M;
                }
                j = r;
            }
        }
    }
    for (int j = 1; j <= n; j++) {
        for (int i = 1; i <= n; i++) {
            if (a[i][j] == '?') {
                int r = i;
                while (a[r][j] == '?')
                    r++;
                if (a[r][j] == '#' && a[i - 1][j] == '#') {
                    cout << 0 << endl;
                    return 0;
                }
                if (a[r][j] == '.' && a[i - 1][j] == '.') {
                    ans = (ans * (r - i + 1)) % M;
                }
                i = r;
            }
        }
    }
    cout << ans << endl;
}
