#include <bits/stdc++.h>

using ll = long long;
using ull = unsigned long long;

using namespace std;

using state = array<int, 6>;
struct Hasher {
	size_t operator()(state const& st) const {
		ull ans = 0;
		for (auto x : st) {
			ans *= 31;
			ans += x;
		}
		return ans;
	}
};

void solveTest() {
	int n;
	cin >> n;
	vector a(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j];
		}
	}
	vector dp(n, vector<unordered_map<state, pair<state, int>, Hasher>>(n));

	auto goDown = [&](int i, int j, state st) {
		state nst{st[1], st[2], st[3], st[0], st[4], st[5]};
		if (nst[0] != -1 && nst[0] != a[i][j]) {
			return;
		}
		nst[0] = a[i][j];
		dp[i][j][nst] = make_pair(st, 0);
	};
	auto goRight = [&](int i, int j, state st) {
		state nst{st[4], st[1], st[5], st[3], st[2], st[0]};
		if (nst[0] != -1 && nst[0] != a[i][j]) {
			return;
		}
		nst[0] = a[i][j];
		dp[i][j][nst] = make_pair(st, 1);
	};

	vector<int> p1{1, 2, 3, 0, 4, 5};
	vector<int> ip1{3, 0, 1, 2, 4, 5};
	vector<int> p2{4, 1, 5, 3, 2, 0};
	vector<int> ip2{5, 1, 4, 3, 0, 2};

	dp[0][0][state{a[0][0], -1, -1, -1, -1, -1}] = make_pair(state{}, -1);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (auto it : dp[i][j]) {
				if (i + 1 < n) {
					goDown(i + 1, j, it.first);
				}
				if (j + 1 < n) {
					goRight(i, j + 1, it.first);
				}
			}
		}
	}
	if (dp[n - 1][n - 1].empty()) {
		cout << "No\n";
		return;
	}
	cout << "Yes\n";

	auto app = [&](state const& st, vector<int> const& p) {
		state res{};
		for (int i = 0; i < 6; ++i) {
			res[i] = st[p[i]];
		}
		return res;
	};

	auto st = dp[n - 1][n - 1].begin()->first;
	auto ans = st;
	int i = n - 1;
	int j = n - 1;
	while (i > 0 || j > 0) {
	// 	for (int& x : ans) {
	// 	// if (x == -1) {
	// 	// 	x = 0;
	// 	// }
	// 	cout << x << ' ';
	// }
		auto[nst, turn] = dp[i][j][st];
		if (turn == 0) {
			--i;
			// cerr << "D" << '\n';
			ans = app(ans, ip1);
		} else {
			--j;
			// cerr << "R" << '\n';;	
			ans = app(ans, ip2);
		}
		st = nst;
	}
	for (int& x : ans) {
		if (x == -1) {
			x = 566;
		}
	}
	cout << ans[0] << ' ' << ans[5] << ' ' << ans[3] << ' ' << ans[1] << ' ' << ans[4] << ' ' << ans[2] << '\n';
}

int main(void) {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;
	while (t--) solveTest();

	return 0;
}