#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;
const int mod = 998'244'353;
vector<vector<int>>g;
vector<int>usd;
int edge = 0;
int dfs(int s, int p) {
	usd[s] = 1;
	int cnt = 1;
	bool loops = false;
	if (g[s].size() == 1) {
		edge = s;
	}
	for (int i = 0; i < g[s].size(); ++i) {
		if (g[s][i] == p) {
			continue;
		}
		if (usd[g[s][i]]) {
			loops = true;
		}
		int r = dfs(g[s][i], s);
		if (r < 0) {
			loops = true;
			r *= -1;
		}
		cnt += r;
	}
	if (loops) {
		cnt *= -1;
	}
	return cnt;
}
int32_t main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	g.assign((n + 1) * (n + 1) * 2 + n * n * 2, {});
	usd.assign(g.size(), 0);
	//i*n+j = horV
	//i*n+j+n*n = verV
	//n*n*2 + i*(n+1)+j=left
	vector<string>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < n; ++q) {
			if (a[i][q] == '?') {
				int hA = 0;
				int vA = 0;
				if (i + 1 == n || a[i + 1][q] != '#') {
					++vA;
					g[i * n + q + n * n].push_back(n * n * 2 + (i + 1) * (n + 1) + q + (n + 1) * (n + 1));
					g[n * n * 2 + (i + 1) * (n + 1) + q + (n + 1) * (n + 1)].push_back(i * n + q + n * n);
				}
				if (i == 0 || a[i - 1][q] != '#') {
					++vA;
					g[i * n + q + n * n].push_back(n * n * 2 + (i) * (n + 1) + q + (n + 1) * (n + 1));
					g[n * n * 2 + (i) * (n + 1) + q + (n + 1) * (n + 1)].push_back(i * n + q + n * n);
				}

				if (q + 1 == n || a[i][q + 1] != '#') {
					++hA;
					g[i * n + q].push_back(n * n * 2 + i * (n + 1) + (q + 1));
					g[n * n * 2 + i * (n + 1) + (q + 1)].push_back(i * n + q);
				}
				if (q == 0 || a[i][q - 1] != '#') {
					++hA;
					g[i * n + q].push_back(n * n * 2 + i * (n + 1) + (q));
					g[n * n * 2 + i * (n + 1) + (q)].push_back(i * n + q);
				}
				if (hA == 0 || vA == 0) {
					cout << 0;
					return 0;
				}
			}
		}
	}
	int ans = 1;
	for (int i = 0; i < g.size(); ++i) {
		if (g[i].size() == 0) {
			continue;
		}
		if (!usd[i]) {
			int r = dfs(i, -1);
			if (r < 0) {
				ans *= 2;
				ans %= mod;
				continue;
			}
			if (r % 2 == 0) {
				continue;
			}
			if (edge < n * n + n * n) {
				cout << 0;
				return 0;
			}
			ans *= (r + 1) / 2;
			ans %= mod;
		}
	}
	cout << ans;
	return 0;
}