#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long

using namespace std;

const int M = 1e6 + 10;

set<pair<int, int>> st;
vector<set<int>> pos;
vector<int> cnt;
ll ans = 0;

void merge(set<pair<int, int>>::iterator it) {
	if (it == st.end() || it == st.begin())
		return;
	auto [l, r] = *it;
	auto [l1, r1] = *prev(it);
	if (cnt[l1] == cnt[l]) {
		st.erase(it);
		st.erase(st.find(make_pair(l1, r1)));
		st.insert({ l1, r });
	}
}

void add(int i) {
	auto it = st.upper_bound(make_pair(i, INT32_MAX));
	assert(it != st.begin());
	it--;
	auto [l, r] = *it;
	// for (auto [l, r] : st)
	// 	cerr << l << " " << r << endl;
	// cerr << l << " " << r << endl;

	if (i != l) {
		// cerr << i << " " << "yes\n";
		pos[cnt[i]].erase(i);
		cnt[i]++;
		pos[cnt[i]].insert(i);
		return;
	}
	// cerr << i << " " << "no\n";
	st.erase(it);
	// for (int i : pos[cnt[i]])
	// 	cerr << i << " ";
	// cerr << endl;
	auto it_j = pos[cnt[i]].upper_bound(i);
	if (it_j != pos[cnt[i]].end() && *it_j < r) {
		int j = *it_j;
		ans += j - l;
		st.insert({ j, r });
		st.insert({ l, j });
	} else {
		ans += r - l;
		st.insert({ l, r });
	}

	pos[cnt[i]].erase(i);
	cnt[i]++;
	pos[cnt[i]].insert(i);

	merge(st.lower_bound(make_pair(l, -1)));
}

void del(int i) {
	if (cnt[i] == 0)
		return;
	auto it = st.upper_bound(make_pair(i, INT32_MAX));
	assert(it != st.begin());
	it--;
	auto [l, r] = *it;
	if (cnt[i] > cnt[l]) {
		pos[cnt[i]].erase(i);
		cnt[i]--;
		pos[cnt[i]].insert(i);
		return;
	}
	// cerr << l << " " << r << endl;
	// for (auto [l, r] : st)
	// 	cerr << l << " " << r << endl;
	st.erase(it);
	ans -= r - i;
	if (l < i)
		st.insert({ l, i });
	st.insert({ i, r });

	pos[cnt[i]].erase(i);
	cnt[i]--;
	pos[cnt[i]].insert(i);
	// auto [L, R] = *st.upper_bound(make_pair(i + 1, INT32_MAX));
	// cerr << L << " " << R << endl;
	merge(st.upper_bound(make_pair(i, INT32_MAX)));
}

void solve() {
	st.clear();
	pos.clear();
	cnt.clear();

	int n;
	cin >> n;
	cnt.resize(n);
	for (int i = 0; i < n; i++)
		cin >> cnt[i];

	pos.resize(M + 1);
	for (int i = 0; i < n; i++) {
		pos[cnt[i]].insert(i);
	}

	int mn = 1e9;
	for (int l = 0; l < n; ) {
		mn = min(mn, cnt[l]);
		int r = l + 1;
		while (r < n && mn <= cnt[r])
			r++;
		mn = min(mn, cnt[l]);
		st.insert({ l, r });
		ans += (r - l) * 1ll * mn;
		l = r;
	}
	// for (auto [l, r] : st)
	// 	cerr << l << " " << r << endl;
	// cerr << "---\n";

	cout << ans << "\n";
	int q;
	cin >> q;
	while (q--) {
		// for (auto [l, r] : st)
		// 	cerr << l << " " << r << endl;

		int p, x;
		cin >> p >> x;
		if (p == 1) {
			add(x);
		} else {
			if (cnt[x] > 0) {
				del(x);
			}
		}
		// pos[cnt[x]].erase(x);
		// cnt[x] += d;
		// for (int i : cnt)
		// 	cerr << i << " ";
		// cerr << endl;
		// pos[cnt[x]].insert(x);

		cout << ans << "\n";

		cout.flush();
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	#ifdef DIMSS
		freopen("test.txt", "r", stdin);
	#endif

	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
		#ifdef DIMSS
			cerr << "--------\n";
		#endif
	}

	return 0;
}
