#include <bits/stdc++.h>

using namespace std;

int d[24][60];

int dx[] = {0, 1};
int dy[] = {1, 0};

int bfs(int sh, int sm, int fh, int fm) {
	for (int i = 0; i < 24; ++i)
		for (int j = 0; j < 60; ++j)
			d[i][j] = (int)1e9;
	d[sh][sm] = 0;

	queue<pair<int, int>> q;
	q.push({sh, sm});

	while (q.size()) {
		auto [h, m] = q.front();
		//cout << h << ":" << m << " = " << d[h][m] << endl;
		q.pop();
		for (int i = 0; i < 2; ++i) {
			int nh = (h + dx[i]) % 24;
			int nm = (m + dy[i]) % 60;
			if (nm < m) {
				nh = (nh + 1) % 24;
			}
			if (d[nh][nm] > d[h][m] + 1) {
				d[nh][nm] = d[h][m] + 1;
				q.push({nh, nm});
			}
		}
	}

	return d[fh][fm];
}

int main() {
	// ios::sync_with_stdio(false);
	// cin.tie(0);

	int h1, m1;
	int h2, m2;
	scanf("%d : %d", &h1, &m1);
	scanf("%d : %d", &h2, &m2);

	printf("%d\n", bfs(h1, m1, h2, m2));


	return 0;
}