#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int MOD = 998244353;

void solve() {
    int n; cin >> n;
    vector<string> v(n + 2);
    v[0] = string(n + 2, '.');
    v[n + 1] = string(n + 2, '.');
    for (int i = 1; i <= n; i++) {
        cin >> v[i];
        v[i] = '.' + v[i] + '.';
    }
    long long ans = 1;
    for (int i = 1; i <= n; i++) {
        char prev = '.';
        int len = 0;
        for (int j = 1; j <= n + 1; j++) {
            if (v[i][j] == '.') {
                if (prev == '.') {
                    ans = ans * (len + 1);
                } else if (prev == '#') {
                    ans = ans;
                }
                prev = '.';
                len = 0;
            } else if (v[i][j] == '#') {
                if (prev == '#' && len > 0) {
                    cout << 0;
                    return;
                } else if (prev == '.') {
                    ans = ans;
                }
                len = 0;
                prev = '#';
            } else {
                len++;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        char prev = '.';
        int len = 0;
        for (int j = 1; j <= n + 1; j++) {
            if (v[j][i] == '.') {
                if (prev == '.') {
                    ans = ans * (len + 1);
                } else if (prev == '#') {
                    ans = ans;
                }
                prev = '.';
                len = 0;
            } else if (v[j][i] == '#') {
                if (prev == '#' && len > 0) {
                    cout << 0;
                    return;
                } else if (prev == '.') {
                    ans = ans;
                }
                prev = '#';
                len = 0;
            } else {
                len++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    //int t; cin >> t; while(t--)
    solve();
    return 0;
}
