#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ld long double
#define eb emplace_back
#define pb push_back
#define f first
#define s second
#define deb(x) cerr << #x << " = " << x << '\n';

typedef tree<
        pair<int, int>,
        null_type,
        less<pair<int, int>>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int inf = 1e9 + 10;
const int INF = 1e18 + 10;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P1 = 31;
const int P2 = 37;
const ld EPS = 1e-9;
const ld PI = acosl(-1);
const int SOTKA = 100;
const int POLTOS = 50;
const int KASAR = 1000;
const int mod = 998244353;

const int dx[9] = {1, -1, 0, 0, 1, 1, -1, -1};
const int dy[9] = {0, 0, 1, -1, 1, -1, 1, -1};

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int dp[1001][1001][8];

vector<vector<char>> a;

vector<int> get_flags(int x, int y) {
    vector<int> res;
    if (a[x][y] == '0') {
        res = {0};
    } else if (a[x][y] == '1') {
        res = {1};
    } else {
        res = {2, 3, 4, 5};
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    a.resize(n, vector<char>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            if (a[i][j] == '.') {
                a[i][j] = '0';
            }
            if (a[i][j] == '#') {
                a[i][j] = '1';
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            for (int k = 0; k < 7; k++) {
                dp[i][j][k] = 0;
            }
        }
    }
    if (a[0][0] != '?') {
        dp[0][0][a[0][0] - '0'] = 1;
    } else {
        for (int i = 2; i < 6; i++) {
            dp[0][0][i] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (!i && !j) {
                continue;
            }
            if (j && !i) {
                vector<int> flags, flagsl;
                flags = get_flags(i, j);
                flagsl = get_flags(i, j - 1);
                for (auto &k: flags) {
                    for (auto &t: flagsl) {
                        if (k == 1 && (t == 3 || t == 4)) {
                            continue;
                        }
                        if ((k == 2 || k == 5) && (t == 1 || t == 3 || t == 4)) {
                            continue;
                        }
                        dp[i][j][k] += dp[i][j - 1][t];
                        dp[i][j][k] %= mod;
                    }
                }
            } else if (i && !j) {
                vector<int> flags, flagsu;
                flags = get_flags(i, j);
                flagsu = get_flags(i - 1, j);
                for (auto &k: flags) {
                    for (auto &t: flagsu) {
                        if (k == 1 && (t == 4 || t == 5)) {
                            continue;
                        }
                        if ((k == 2 || k == 3) && (t == 1 || t == 4 || t == 5)) {
                            continue;
                        }
                        dp[i][j][k] += dp[i - 1][j][t];
                        dp[i][j][k] %= mod;
                    }
                }
            } else {
                vector<int> flags, flagsu, flagsl, flagsul;
                flags = get_flags(i, j);
                flagsu = get_flags(i - 1, j);
                flagsl = get_flags(i, j - 1);
                flagsul = get_flags(i - 1, j - 1);
                for (auto &k: flags) {
                    int good_sum1 = 0;
                    int good_sum2 = 0;
                    int bad_sum = 0;
                    vector<int> flags_good_left;
                    vector<int> flags_good_up;
                    for (auto &t: flagsu) {
                        for (auto &te: flagsl) {

                            if (t == 1 && (k == 4 || k == 5)) {
                                continue;
                            }
                            if ((t == 2 || t == 3) && (k == 1 || k == 4 || k == 5)) {
                                continue;
                            }
                            if (te == 1 && (k == 3 || k == 4)) {
                                continue;
                            }
                            if ((te == 2 || te == 5) && (k == 1 || k == 3 || k == 4)) {
                                continue;
                            }
                            bad_sum += dp[i - 1][j][t] * dp[i][j - 1][te];
                            bad_sum %= mod;
                            flags_good_up.push_back(t);
                            if (bad_sum == 0)
                                continue;
                            for (auto &tt : flagsul){
                                bool f1 = true, f2 = true;
                                if (tt == 1 && (te == 4 || te == 5)) {
                                    f1 = false;
                                }
                                if ((tt == 2 || tt == 3) && (te == 1 || te == 4 || te == 5)) {
                                    f1 = false;
                                }
                                if (tt == 1 && (t == 3 || t == 4)) {
                                    f2 = false;
                                }
                                if ((tt == 2 || tt == 5) && (t == 1 || t == 3 || t == 4)) {
                                    f2 = false;
                                }

                                if (f2 != f1){
                                    bad_sum -= f2 * (dp[i - 1][j][t]) * dp[i - 1][j - 1][tt];
                                    bad_sum -= f1 * (dp[i][j - 1][te])* dp[i - 1][j - 1][tt];
                                    bad_sum += mod;
                                    bad_sum %= mod;
                                }
                            }
                        }
                    }
                    dp[i][j][k] = bad_sum;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < 6; i++) {
        ans += dp[n - 1][n - 1][i];
        ans %= mod;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    //    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
