#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ld long double
#define eb emplace_back
#define pb push_back
#define f first
#define s second
#define deb(x) cerr << #x << " = " << x << '\n';

typedef tree <
        pair <int, int>,
        null_type,
        less<pair <int, int>>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int inf = 1e9 + 10;
const int INF = 1e18 + 10;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P1 = 31;
const int P2 = 37;
const ld EPS = 1e-9;
const ld PI = acosl(-1);
const int SOTKA = 100;
const int POLTOS = 50;
const int KASAR = 1000;

const int dx[9] = {1, -1, 0, 0, 1, 1, -1, -1};
const int dy[9] = {0, 0, 1, -1, 1, -1, 1, -1};

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct item{
    int x, l, r;
    int len(){
        return r - l + 1;
    }
};

bool comp(item a, item b){
    return a.len() < b.len();
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector <string> v(n);

    for (auto &i: v)
        cin >> i;


    vector <item> ver, hor;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            if (v[i][j] != '.')
                continue;

            if (j != 0 && v[i][j - 1] == '.'){
                ver.back().r++;
            }
            else{
                ver.push_back({i, j, j});
            }
        }
    }


    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            if (v[j][i] != '.')
                continue;

            if (j != 0 && v[j - 1][i] == '.'){
                hor.back().r++;
            }
            else{
                hor.push_back({i, j, j});
            }
        }
    }

//    for (auto &i: ver){
//        cout << i.x << ' ' << i.l  << ' ' << i.r << '\n';
//    }
//    cout << "-------------------------\n";
//
//    for (auto &i: hor){
//        cout << i.x << ' ' << i.l  << ' ' << i.r << '\n';
//    }
//    cout << "-------------------------\n";

    sort(ver.begin(), ver.end(), comp);
    sort(hor.begin(), hor.end(), comp);


    int ans = 0;
    if (ver.size() >= 2){
        ans = ver.back().len() + ver[ver.size() - 2].len();
    }
    else if (!ver.empty()){
        ans = ver.back().len();
    }


    if (hor.size() >= 2){
        ans = max(ans, hor.back().len() + hor[hor.size() - 2].len());
    }
    else if (!hor.empty()){
        ans = max(ans, hor.back().len());
    }

    for (int i = (int)ver.size() - 1; i >= 0; i--){
        for (int j = (int)hor.size() - 1; j >= 0; j--){
            if (ans > ver[i].len() + hor[j].len())
                break;

            int cur = ver[i].len();
            if (ver[i].x >= hor[j].l && ver[i].x <= hor[j].r && hor[j].x >= ver[i].l && hor[j].x <= ver[i].r){
                cur += max(ver[i].x - hor[j].l, hor[j].r - ver[i].x);
            }

            ans = max(ans, cur);
        }
    }

    for (int i = (int)hor.size() - 1; i >= 0; i--){
        for (int j = (int)ver.size() - 1; j >= 0; j--){
            if (ans > hor[i].len() + ver[j].len())
                break;

            int cur = hor[i].len();
            if (hor[i].x >= ver[j].l && hor[i].x <= ver[j].r && ver[j].x >= hor[i].l && ver[j].x <= hor[i].r){
                cur += max(hor[i].x - ver[j].l, ver[j].r - hor[i].x);
            }

            ans = max(ans, cur);
        }
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--){
        solve();
    }
    return 0;
}