#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#endif
using namespace std;

#define int long long

void solve() {
    string start;
    string finish;
    cin >> start;
    cin >> finish;
    auto to_int = [&](const string& s) {
        int hh = (s[0] - '0') * 10 + (s[1] - '0');
        int mm = (s[3] - '0') * 10 + (s[4] - '0');
        return tuple{hh, mm};
    };
    int n = 24 * 60;
//    cout << n << endl;
    unordered_map<string, int> dist(n);
    deque<string> q;
    dist[start] = 0;
    q.push_back(start);
    auto prev_h = [&](int h, int m) {
        if (h > 0) {
            return tuple{h - 1, m};
        }
        return tuple{23LL, m};
    };
    auto next_hh = [&](int h, int m) {
        if (h < 23) {
            return tuple{h + 1, m};
        }
        return tuple{0LL, m};
    };
    auto prev_m = [&](int h, int m) {
        if (m > 0) {
            return tuple{h, m - 1};
        }
        auto [hh, mm] = prev_h(h, m);
        return tuple{hh, 59LL};
    };
    auto next_mm = [&](int h, int m) {
        if (m < 59) {
            return tuple{h, m + 1};
        }
        auto [hh, mm] = next_hh(h, m);
        return tuple{hh, 0LL};
    };
    auto to_str = [&](int h, int m) {
//        cout << "h = " << h << ", m = " << m << endl;
       string hhh = to_string(h);
       string mmm = to_string(m);
       if (hhh.size() == 1) {
           hhh = "0" + hhh;
       }
       if (mmm.size() == 1) {
           mmm = "0" + mmm;
       }
       return hhh + ":" + mmm;
    };
    while (q.size() > 0) {
        string u = q.front();
        q.pop_front();
//        cout << "u = " << u << endl;
        auto [h, m] = to_int(u);
//        {
//            auto [next_h, next_m] = prev_h(h, m);
//            string next = to_str(next_h, next_m);
//            if (!dist.count(next)) {
//                dist[next] = dist[u] + 1;
//                q.push_back(next);
//            }
//        }
        {
            auto [next_h, next_m] = next_hh(h, m);
            string next = to_str(next_h, next_m);
            if (!dist.count(next)) {
                dist[next] = dist[u] + 1;
                q.push_back(next);
            }
        }
//        {
//            auto [next_h, next_m] = prev_m(h, m);
//            string next = to_str(next_h, next_m);
//            if (!dist.count(next)) {
//                dist[next] = dist[u] + 1;
//                q.push_back(next);
//            }
//        }
        {
            auto [next_h, next_m] = next_mm(h, m);
            string next = to_str(next_h, next_m);
            if (!dist.count(next)) {
                dist[next] = dist[u] + 1;
                q.push_back(next);
            }
        }
    }
    cout << dist[finish] << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> T;
#endif
    for (int t = 0; t < T; ++t) {
        solve();
    }
}
