#include <bits/stdc++.h>

#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define all(a) a.begin(), a.end()
#define ll long long
#define forn(i, j, n) for(int i = j; i < n; i++)

using namespace std;

void print(pair<pair<int, int>, pair<int, int>> a) {
    cout << a.first.first << ' ' << a.first.second << ' ' << a.second.first << ' ' << a.second.second << '\n';
}

auto get_mx(const vector<vector<int>> &tab) {
    int n = tab.size();
    int m = tab[0].size();
    vector<pair<int, pair<pair<int, int>, pair<int, int>>>> ans;

    int cur = 0;
    int l = 0, r = 0;
    forn(i, 0, n) {
        l = 0, r = 0, cur = 0;
        forn(j, 0, m) {
            if (tab[i][j] == 0) {
                cur++;
                r = j;
            }
            if (tab[i][j] == 1 || j == m - 1) {
                if (cur > 0) {
                    ans.push_back(mp(cur, mp(mp(i, l), mp(i, r))));
                }
                l = j + 1;
                r = l;
                cur = 0;
            }
        }
    }
    cur = 0, l = 0, r = 0;
    forn(j, 0, m) {
        cur = 0, l = 0, r = 0;
        forn(i, 0, n) {
            if (tab[i][j] == 0) {
                cur++;
                r = i;
            }
            if (tab[i][j] == 1 || i == n - 1) {
                if (cur > 0) {
                    ans.push_back(mp(cur, mp(mp(l, j), mp(r, j))));
                }
                l = i + 1;
                r = l;
                cur = 0;
            }
        }
    }
    sort(all(ans));
    ans.resize(unique(all(ans)) - ans.begin());
    reverse(all(ans));
    return ans;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> tab(n, vector<int>(m, 0));
    forn(i, 0, n) {
        string s;
        cin >> s;
        forn(j, 0, m) {
            char c = s[j];
            if (c == '#') {
                tab[i][j] = 1;
            } else {
                tab[i][j] = 0;
            }
        }
    }

    vector<pair<int, pair<pair<int, int>, pair<int, int>>>> res = get_mx(tab);

//    for (auto v: res) {
//        cout << v.first << ' ';
//        print(v.second);
//    }

    if (res.size() == 0) {
        cout << 0 << '\n';
        return;
    }
    if (res.size() == 1) {
        cout << res[0].ff << '\n';
        return;
    }

    int len_a = res[0].ff;
    int len_b = res[1].ff;

    pair<pair<int, int>, pair<int, int>> a = res[0].ss;
    pair<pair<int, int>, pair<int, int>> b = res[1].ss;

    vector<vector<int>> tab_a = tab;
    for (int i = a.first.first; i <= a.second.first; i++) {
        for (int j = a.first.second; j <= a.second.second; j++) {
            tab_a[i][j] = 1;
        }
    }

    vector<vector<int>> tab_b = tab;
    for (int i = b.first.first; i <= b.second.first; i++) {
        for (int j = b.first.second; j <= b.second.second; j++) {
            tab_b[i][j] = 1;
        }
    }

    vector<pair<int, pair<pair<int, int>, pair<int, int>>>> res_a = get_mx(tab_a);
    vector<pair<int, pair<pair<int, int>, pair<int, int>>>> res_b = get_mx(tab_b);

    int len_res_a = (res_a.size() > 0 ? res_a[0].ff : 0);
    int len_res_b = (res_b.size() > 0 ? res_b[0].ff : 0);

    int ans = max(len_a + len_res_a, len_b + len_res_b);

    cout << ans << '\n';
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
