
#include <iostream>
#include <vector>
using ll =long long;
#include <algorithm>
#include <set>
#include <map>
using namespace std;

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<vector<bool>> x(n, vector<bool>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			cin >> c;
			x[i][j] = (c == '.');
		}
	}

	vector<ll> kek = { 0, 0 };
	for (int i = 0; i < n; i++) {
		int a = 0;
		for (int j = 0; j < m; j++) {
			if (x[i][j]) a++;
			else {
				kek.push_back(a);
				a = 0;
			}
		}
		kek.push_back(a);
	}

	sort(kek.begin(), kek.end());
	ll ans = kek[kek.size() - 1] + kek[kek.size() - 2];
	kek = { 0, 0 };
	for (int j = 0; j < m; j++) {
		int a = 0;
		for (int i = 0; i < n; i++) {
			if (x[i][j]) a++;
			else {
				kek.push_back(a);
				a = 0;
			}
		}
		kek.push_back(a);
	}
	sort(kek.begin(), kek.end());
	ll ans1 = kek[kek.size() - 1] + kek[kek.size() - 2];
	
	ans = max(ans, ans1);
	
	set <ll> s = { 0 };
	map<ll, ll> mp;
	vector<vector<pair<ll, ll>>> hor(n, vector<pair<ll,ll>>(m)), vert(n, vector<pair<ll, ll>>(m));

	for (int i = 0; i < n; i++) {
		int a = 0;
		for (int j = 0; j < m; j++) {
			if (x[i][j] == 1)
				a++;
			else {
				for (int k = j - a; k < j; k++) {
					hor[i][k] = { k - (j - a) + 1, a };
				}
				mp[a]++;
				s.insert(a);
				a = 0;
			}
		}
		mp[a]++;
		s.insert(a);
		for (int k = m - a; k < m; k++) {
			hor[i][k] = { k - (m - a) + 1, a };
		}
	}

	for (int j = 0; j < m; j++) {
		int a = 0;
		for (int i = 0; i < n; i++) {
			if (x[i][j] == 1)
				a++;
			else {
				for (int k = i - a; k < i; k++) {
					vert[k][j] = { k - (i - a) + 1, a };
				}
				a = 0;
			}
		}

		for (int k = n - a; k < n; k++) {
			vert[k][j] = { k - (n - a) + 1, a };
		}
	}

	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (vert[i][j].first == 1) {
				ll ma = 0;
				for (int k = i; k < i + vert[i][j].second; k++) {
					ll l = hor[k][j].second;
					mp[l]--;
					if (mp[l] == 0)
						s.erase(l);
					ma = max(ma, hor[k][j].first - 1);
					ma = max(ma, hor[k][j].second - hor[k][j].first);
				}

				s.insert(0);
				ll cur_ans = vert[i][j].second + max(ma, *s.rbegin());
				ans = max(ans, cur_ans);

				for (int k = i; k < i + vert[i][j].second; k++) {
					ll l = hor[k][j].second;
					mp[l]++;
					if (mp[l] == 1)
						s.insert(l);
					
				}
			}
		}
	}

	cout << ans << '\n';

}


int main(){
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
1
4 5
###.#
#....
.##.#
#.#.#

*/
