#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define vi vector<int>
#define pii pair<int, int>
#define vec vector

vec<pair<int, pii>> count(const vec<vec<char>>& a, bool inv, bool ss) {
	vec<pair<int, pii>> v; v.reserve(a.size());
	for (int i = 0; i < a.size(); ++i) {
		int s = 0, l = 0;
		for (int j = 0; j < a[i].size(); ++j) {
			if (a[i][j] == '#') {
				if (l) {
					v.push_back({ l, {i, s} });
					if (inv) swap(v.back().second.first, v.back().second.second);
				}
				l = 0;
				s = j + 1;
			}
			else ++l;
		}
		if (l) {
			v.push_back({ l, {i, s} });
			if (inv) swap(v.back().second.first, v.back().second.second);
		}
	}

	v.push_back({ 0, {0, 0} });
	v.push_back({ 0, {0, 0} });

	if (ss) {
		return { *max_element(v.begin(), v.end()) };
	}std::sort(v.rbegin(), v.rend());
	return v;
}
vec<vec<pii>> cc(const vec<vec<char>>& a) {
	int m = a[0].size();
	vec<vec<pii>> l_r(a.size(), vec<pii>(m));
	for (int i = 0; i < a.size(); ++i) {
		int lpos = 0;
		for (int j = 0; j < m; ++j) {
			if (a[i][j] == '#') lpos = j;
			l_r[i][j].first = lpos;
		}
		lpos = m - 1;
		for (int j = m - 1; j > -1; --j) {
			if (a[i][j] == '#') lpos = j;
			l_r[i][j].second = lpos;
		}
	}
	return l_r;
}

template<typename T>
vec<vec<T>> tr(const vec<vec<T>>& a) {
	vec<vec<T>> x(a[0].size(), vec<T>(a.size()));
	for (int i = 0; i < a.size(); ++i) {
		for (int j = 0; j < a[0].size(); ++j)
			x[j][i] = a[i][j];
	}
	return x;
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vec<vec<char>> a(n, vec<char>(m));
		for (auto& e : a) for (auto& ee : e) cin >> ee;
		vec<vec<char>> b = tr(a);
		auto x = count(a, 0, 0), y = count(b, 1, 0);

		int ans = max(x[0].first + x[1].first, y[0].first + y[1].first);
		vec<vec<pii>> l_r = cc(a);
		vec<vec<pii>> u_d = tr(cc(b));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				
				int v1 = (j - l_r[i][j].first) + (u_d[i][j].second - u_d[i][j].first) - 2;
				int v2 = (l_r[i][j].second - j) + (u_d[i][j].second - u_d[i][j].first) - 2;
				int v3 = (i - u_d[i][j].first) + (l_r[i][j].second - l_r[i][j].first) - 2;
				int v4 = (u_d[i][j].second - i) + (l_r[i][j].second - l_r[i][j].first) - 2;
				ans = max({ ans,  v1, v2, v3, v4 });
			}
		}
		for (int j = 0; j < x[0].first; ++j) {
			b[x[0].second.second + j][x[0].second.first] = '#';
		}
		ans = max(ans, x[0].first + count(b, 0, 1).front().first);
		for (int j = 0; j < y[0].first; ++j) {
			a[y[0].second.first + j][y[0].second.second] = '#';
		}
		ans = max(ans, y[0].first + count(a, 0, 1).front().first);
		cout << ans << "\n";
	}
}