#include <bits/stdc++.h>
#define IOS ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#define vc vector
#define vi vector<int>
#define vll vector<long long>
#define forn(i,s,n) for(int i = (s); i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define f first
#define s second
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

const int INF = 2e9;
const ll INFL = 1e18;
const int PI = atan(1) * 4;
const int MXN = 1e6;
const int MOD = 1e9 + 7;

basic_istream<char> &operator>>(basic_istream<char> &in, vi &a) {
    forn(i, 0, a.size()) {
        in >> a[i];
    }
    return in;
}

basic_ostream<char> &operator<<(basic_ostream<char> &out, vi &a) {
    forn(i, 0, a.size()) {
        out << a[i] << ' ';
    }
    return out;
}

struct pt {
    int x, y;
    explicit pt(int x = 0, int y = 0) : x(x), y(y) {}
};

struct vec {
    int x, y;
    explicit vec(int x = 0, int y = 0): x(x), y(y) {}
    vec(pt a, pt b): x(b.x - a.x), y(b.y - a.y) {}
    ld len() {return sqrt(x * x + y * y);}
    ll dot(vec b) {return x * b.x + y * b.y;}
    vec cross(vec b) {return vec(x * b.y, -y * b.x);}
};

struct seg_tree {
    vi tree;
    seg_tree(vi &a) {
        tree.assign(4 * a.size(), 0);
        build(a, 0, 0, a.size());
    }
    void build(vi &a, int t, int l, int r) {
        if (l + 1 == r) {
            tree[t] = a[t];
            return;
        }
        int m = (l + r)/2;
        build(a, 2 * t + 1, l, m);
        build(a, 2 * t + 2, m, r);
        tree[t] = tree[2 * t + 1] + tree[2 * t + 2];
    }
    void upd(int t, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            tree[t] = val;
            return;
        }
        int m = (l + r)/2;
        if (pos < m) upd(2 * t + 1, l, m, pos, val);
        else upd(2 * t + 2, m, r, pos, val);
        tree[t] = tree[2 * t + 1] + tree[2 * t + 2];
    }
    int ask(int t, int l, int r, int x, int y) {
        if (y <= l || r <= x) return 0;
        if (x <= l && r <= y) return tree[t];
        int m = (l + r)/2;
        return ask(2 * t + 1, l, m, x, y) + ask(2 * t + 2, m, r, x, y);
    }
};

ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}

ll binPow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2) return a * binPow(a, n - 1);
    else {
        ll x = binPow(a, n/2);
        return x * x;
    }
}

void solve(){
    int n, m;
    vector<vector<int>> g;
    vector<pair<vector<int>, vector<int>>> cols, rows;
    cin >> n >> m;
    g.assign(n, vector<int>(m));
    cols.resize(m);
    rows.resize(n);
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            char c;
            cin >> c;
            if (c == '#') {
                g[i][j] = -1;
            } else {
                g[i][j] = 1;
            }
        }
    }


    int ans = 0;

    int amx1 = -1, amx2 = -1;

    for (int i = 0; i < n; ++i){
        vector<int> mx1 = {-1, -1, -1}, mx2 = {-1, -1, -1};
        int s = 0, cur = 0;
        for (int j = 0; j < m; ++j) {
            if (g[i][j] == 1) {
                if (cur == 0) {
                    s = j;
                }
                cur++;
            } else if (g[i][j] == -1 && cur != 0) {
                if (mx1[0] < cur) {
                    mx2 = mx1;
                    mx1 = {cur, s, j - 1};
                } else if (mx2[0] < cur) {
                    mx2 = {cur, s, j - 1};
                }
                cur = 0;
            }
        }
        if (cur != 0) {
            if (mx1[0] < cur) {
                mx2 = mx1;
                mx1 = {cur, s, m - 1};
            } else if (mx2[0] < cur) {
                mx2 = {cur, s, m - 1};
            }
        }
        if (mx1[0] > amx1) {
            amx2 = amx1;
            amx1 = mx1[0];
        } else if (mx1[0] > amx2) {
            amx2 = mx1[0];
        }
        rows[i] = {mx1, mx2};
    }
    ans = max(amx2, 0) + max(amx1, 0);
    amx1 = -1;
    amx2 = -1;
    for (int j = 0; j < m; ++j){
        if (j == 5) {
            j = 5;
        }
        vector<int> mx1 = {-1, -1, -1}, mx2 = {-1, -1, -1};
        int s = 0, cur = 0;
        for (int i = 0; i < n; ++i){
            if (g[i][j] == 1) {
                if (cur == 0){
                    s = i;
                }
                cur++;
            } else if (g[i][j] == -1 && cur != 0) {
                if (mx1[0] < cur) {
                    mx2 = mx1;
                    mx1 = {cur, s, i - 1};
                }
                else if (mx2[0] < cur) {
                    mx2 = {cur, s, i - 1};
                }
                cur = 0;
            }
        }
        if (cur != 0) {
            if (mx1[0] < cur) {
                mx2 = mx1;
                mx1 = {cur, s, n - 1};
            } else if (mx2[0] < cur) {
                mx2 = {cur, s, n - 1};
            }
        }
        if (mx1[0] > amx1) {
            amx2 = amx1;
            amx1 = mx1[0];
        } else if (mx1[0] > amx2) {
            amx2 = mx1[0];
        }
        cols[j] = {mx1, mx2};
    }

    ans = max(ans, max(amx1, 0) + max(amx2, 0));

//    for (int i = 0; i < n; ++i) {
//        cout << rows[i].first << " | " << rows[i].second << "\n";
//    }
//
//    for (int i = 0; i < m; ++i) {
//        cout << cols[i].first << " | " << cols[i].second << "\n";
//    }
//    cout << endl;

    for (int i = 0; i < n; ++i) {
        if (rows[i].first[0] == -1) continue;
        for (int j = 0; j < m; ++j) {
            if (cols[j].first[0] == -1) continue;
            if (!(i >= cols[j].first[1] && i <= cols[j].first[2] &&
                j >= rows[i].first[1] && j <= rows[i].first[2])){
                ans = max(ans, max(0, rows[i].first[0]) + max(0, cols[j].first[0]));
            } else {
                int cl1 = i - cols[j].first[1];
                int cl2 = cols[j].first[0] - cl1 - 1;
                int rl1 = j - rows[i].first[1];
                int rl2 = rows[i].first[0] - rl1 - 1;
                assert(cl1 + cl2 == cols[j].first[0] - 1);
                assert(rl1 + rl2 == rows[i].first[0] - 1);
                cl1 = max(cl1, cl2);
                rl1 = max(rl1, rl2);
                ans = max({ans, cl1 + rows[i].first[0], rl1 + cols[j].first[0]});
                if (rows[i].second[0] != -1) {
                    ans = max(ans, cols[j].first[0] + rows[i].second[0]);
                }
                if (cols[j].second[0] != -1) {
                    ans = max(ans, cols[j].second[0] + rows[i].first[0]);
                }
            }
        }
    }
    cout << ans << "\n";
}

int main() {
    IOS;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*
  5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

  */