#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef string str;
#define int ll
#define $ '\n'
#define forn(___i,___n) for(___i=0;___i<n;++___i)
#define max3(_a,_b,_c) (max(max(_a,_b),_c))
#define min3(_a,_b,_c) (min(min(_a,_b),_c))
#define vec vector
#define len(__o) ((int)__o.size())
#define girlfriend friend
#define boyfriend friend
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()

str ALPHA = "abcdefghijklmnopqrstuvwxyz";

typedef vector<int> vi;
typedef vector<int> veci;
typedef pair<int, int> prii;
typedef vector<veci> graph;

inline const constexpr int md(int a, int m) {
    return ((a + m) % m + m) % m;
}

template <class T> istream &operator >> (istream &i, vec<T> &a) {
    for (T &e : a) i >> e;
    return i;
}
template<class T> ostream &operator << (ostream &o, const vec<T> &a) {
    for (const T &e : a) o << e << ' ';
    return o;
}

mt19937 rnd();
const int MOD = 1'000'000'007;
inline void solve();
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;  cin >> t;
    while (t--) solve();
    return 0;
}

inline void solve() {
    int n, m; cin >> n >> m;
    vec<str> a(n); cin >> a;
    vec<vec<veci>> cnt(n, vec<veci>(m, veci(4, 0)));

    vec<veci> lpos(n, veci(m, -1));
    vec<veci> upos(n, veci(m, -1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.') {
                lpos[i][j] = j;
                upos[i][j] = i;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int ri = n - 1 - i, rj = m - 1 - j;
            if (a[i][j] == '.') {
                cnt[i][j][0] = (j > 0 ? cnt[i][j - 1][0] : 0) + 1;
                cnt[i][j][1] = (i > 0 ? cnt[i - 1][j][1] : 0) + 1;

                if (j > 0 && lpos[i][j - 1] != -1) lpos[i][j] = lpos[i][j - 1];
                if (i > 0 && upos[i - 1][j] != -1) upos[i][j] = upos[i - 1][j];
            } else {
                cnt[i][j][0] = 0;
                cnt[i][j][1] = 0;
            }

            if (a[ri][rj] == '.') {
                cnt[ri][rj][2] = (rj < m - 1 ? cnt[ri][rj + 1][2] : 0) + 1;
                cnt[ri][rj][3] = (ri < n - 1 ? cnt[ri + 1][rj][3] : 0) + 1;
            } else {
                cnt[ri][rj][2] = 0;
                cnt[ri][rj][3] = 0;
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#') continue;
            ans = max(ans,
                      accumulate(all(cnt[i][j]), 0ll)
                      - 2
                      - *min_element(all(cnt[i][j])));
        }
    }

    int ln = 0, pi = -1, pj = -1;
    bool vert = false;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (ln < cnt[i][j][2]) {
                vert = false;
                ln = cnt[i][j][2];
                pi = i;
                pj = lpos[i][j];
            }
            if (ln < cnt[i][j][3]) {
                vert = true;
                ln = cnt[i][j][3];
                pi = upos[i][j];
                pj = j;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (vert && j != pj) {
                ans = max(ans, ln + cnt[i][j][1]);
            } else if (!vert && i != pi) {
                ans = max(ans, ln + cnt[i][j][0]);
            }
            if (!(pi <= i && i <= pi + ln - 1)) {
                ans = max(ans, ln + cnt[i][j][0]);
            } else if (!(pj <= j && j <= pj + ln - 1)) {
                ans = max(ans, ln + cnt[i][j][1]);
            }
        }
    }
  //  cerr << cnt[0][0] << $ << cnt[1][0] << $;
  //  cout << vert << "| " << ln << " " << pi << " " << pj << " |   " << ans << $;
  cout << ans << $;
}

/*
5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

 */