#include <iostream>
#include <bits/stdc++.h>

#define endl '\n'

typedef long long ll;


using namespace std;
const int inf = 1e9;

int result(vector<int>& arr1, vector<int>& arr2, int i1, int i2) {
    int res1 = 0;
    int res2 = 0;
    if (i1 >= 0 && i1 < arr1.size()) res1 = arr1[i1];
    if (i2 >= 0 && i2 < arr2.size()) res2 = arr2[i2];
    return res1 + res2;
}

struct arr {
    vector<int> maxes;
    bool h;
    bool pref;

};

void update_two(int& top1, int& top2, int val) {
    if (val >= top1) {
        top2 = top1;
        top1 = val;
    }
    else if (val > top2) top2 = val;
}

void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<char>> a(n, vector<char>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> a[i][j];
            }
        }
        vector<vector<int>> h_pref(n, vector<int>(m, 0)), h_suf(n, vector<int>(m, 0)),
                v_suf(m, vector<int>(n, 0)), v_pref(m, vector<int>(n, 0));

        int row_top1 = -inf;
        int row_top2 = -inf;

        int col_top1 = -inf;
        int col_top2 = -inf;

        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < m; j++) {
                if (a[i][j] == '#') {
                    cur = 0;
                }
                else cur++;
                h_pref[i][j] = j == 0 ? cur : max(h_pref[i][j-1], cur);
            }
            int row_res = h_pref[i][m-1];// = m == 1 ? cur : max(h_pref[i][m-2], cur);
            update_two(row_top1, row_top2, row_res);

            cur = 0;
            for (int j = m-1; j >= 0; --j) {
                if (a[i][j] == '#') {
                    cur = 0;
                }
                else cur++;
                h_suf[i][j] = j == m-1 ? cur : max(h_suf[i][j+1], cur);
            }
           // h_suf[i][0] = m == 1 ? cur : max(h_suf[i][1], cur);
        }

        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {

                if (a[i][j] == '#') {
                    cur = 0;
                }
                else cur++;
                v_pref[j][i] = i == 0 ? cur : max(v_pref[j][i-1], cur);
            }
            int col_res = v_pref[j][n-1];// = n == 1 ? cur : max(v_pref[j][n-2], cur);
            update_two(col_top1, col_top2, col_res);

            cur = 0;
            for (int i = n-1; i >= 0; --i) {
                if (a[i][j] == '#') {
                    cur = 0;
                }
                else cur++;
                v_suf[j][i] = i == n-1 ? cur : max(v_suf[j][i+1], cur);
            }
            //v_suf[j][0] = n == 1 ? cur : max(v_suf[j][1], cur);
        }
        int best = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                for (int arr1 = 0; arr1 < 4; arr1++) {
                    for (int arr2 = 0; arr2 < 4; arr2++) {
                        if (arr1 == arr2) continue;
                        bool same_hv = max(arr1, arr2) == 1 || min(arr1, arr2) == 2;
                        vector<int>*v1;
                        int i1;
                        if (arr1 == 0) {
                            v1 = &h_pref[i];
                            if (!same_hv) i1 = m-1;
                            else i1 = j;
                        }
                        else if (arr1 == 1) {
                            v1 = &h_suf[i];
                            if (!same_hv) i1 = 0;
                            else i1 = j;
                        }
                        else if (arr1 == 2) {
                            v1 = &v_pref[j];
                            if (!same_hv) i1 = n-1;
                            else i1 = i;
                        }
                        else {
                            v1 = &v_suf[j];
                            if (!same_hv) i1 = 0;
                            else i1 = i;
                        }

                        vector<int>*v2;
                        int i2;
                        if (arr2 == 0) {
                            v2 = &h_pref[i];
                            if (!same_hv) i2 =j-1;
                            else i2 = j-1;
                        }
                        else if (arr2 == 1) {
                            v2 = &h_suf[i];
                            if (!same_hv) i2= j+1;
                            else i2 = j + 1;
                        }
                        else if (arr2 == 2) {
                            v2 = &v_pref[j];
                            if (!same_hv) i2 = i-1;
                            else i2 = i - 1;
                        }
                        else {
                            v2 = &v_suf[j];
                            if (!same_hv) i2 =  i+1;
                            else i2 = i + 1;
                        }

                        best = max(best, result(*v1, *v2, i1, i2));
                    }
                }
            }
        }
        best = max(best, row_top1 + row_top2);
        best = max(best, col_top1 + col_top2);
        cout << best << endl;

    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}


