#include <bits/stdc++.h>

using namespace std;

int solve(int n, int m, vector<vector<bool>> table) {
    int ans = 0;

    vector<int> horizontal;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!table[i][j]) {
                continue;
            }
            int k = j + 1;
            while (k < m && table[i][k]) {
                ++k;
            }
            horizontal.push_back(k - j);
            j = k - 1;
        }
    }
    sort(horizontal.begin(), horizontal.end());
    if (horizontal.size() == 1) {
        ans = max(ans, horizontal[0]);
    } else if (horizontal.size() >= 2) {
        int l = (int)horizontal.size();
        ans = max(ans, horizontal[l - 2] + horizontal[l - 1]);
    }

    vector<int> max_vert(m, 0);

    vector<int> vertical;
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            if (!table[i][j]) {
                continue;
            }
            int k = i + 1;
            while (k < n && table[k][j]) {
                ++k;
            }
            vertical.push_back(k - i);
            max_vert[j] = max(max_vert[j], k - i);
            i = k - 1;
        }
    }
    sort(vertical.begin(), vertical.end());
    if (vertical.size() == 1) {
        ans = max(ans, vertical[0]);
    } else if (vertical.size() >= 2) {
        int l = (int)vertical.size();
        ans = max(ans, vertical[l - 2] + vertical[l - 1]);
    }

    vector<int> max_vert_pref(m, 0);

    max_vert_pref[0] = max_vert[0];
    for (int j = 1; j < m; ++j) {
        max_vert_pref[j] = max(max_vert_pref[j - 1], max_vert[j]);
    }

    vector<int> max_vert_suf(m, 0);

    max_vert_suf[m - 1] = max_vert[m - 1];
    for (int j = m - 2; j >= 0; --j) {
        max_vert_suf[j] = max(max_vert_suf[j + 1], max_vert[j]);
    }

    vector<vector<int>> max_vert_incl_up(n, vector<int>(m, 0));

    for (int j = 0; j < m; ++j) {
        if (table[0][j]) {
            max_vert_incl_up[0][j] = 1;
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (table[i][j]) {
                max_vert_incl_up[i][j] = max_vert_incl_up[i - 1][j] + 1;
            } else {
                max_vert_incl_up[i][j] = 0;
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            max_vert_incl_up[i][j] = max(max_vert_incl_up[i][j], max_vert_incl_up[i - 1][j]);
        }
    }

    vector<vector<int>> max_vert_incl_down(n, vector<int>(m, 0));

    for (int j = 0; j < m; ++j) {
        if (table[n - 1][j]) {
            max_vert_incl_down[n - 1][j] = 1;
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            if (table[i][j]) {
                max_vert_incl_down[i][j] = max_vert_incl_down[i + 1][j] + 1;
            } else {
                max_vert_incl_down[i][j] = 0;
            }
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            max_vert_incl_down[i][j] = max(max_vert_incl_down[i][j], max_vert_incl_down[i + 1][j]);
        }
    }

    vector<vector<int>> max_vert_not_incl(n, vector<int>(m, 0));

    if (n >= 2) {
        for (int j = 0; j < m; ++j) {
            max_vert_not_incl[0][j] = max_vert_incl_down[1][j];
        }
    }
    for (int i = 1; i < n - 1; ++i) {
        for (int j = 0; j < m; ++j) {
            max_vert_not_incl[i][j] = max(max_vert_incl_up[i - 1][j], max_vert_incl_down[i + 1][j]);
        }
    }
    if (n >= 2) {
        for (int j = 0; j < m; ++j) {
            max_vert_not_incl[n - 1][j] = max_vert_incl_up[n - 2][j];
        }
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << max_vert_not_incl[i][j] << " ";
//        }
//        cout << endl;
//    }

    for (int i = 0; i < n; ++i) {
        int max_not_incl = 0;
        int l = 0;
        for (int j = 0; j < m; ++j) {
            if (!table[i][j]) {
                max_not_incl = 0;
                l = 0;
                continue;
            }
            max_not_incl = max(max_not_incl, max_vert_not_incl[i][j]);
            l += 1;
            int tmp = 0;
            if (j - l >= 0) {
                tmp = max(tmp, max_vert_pref[j - l]);
            }
            if (j < m - 1) {
                tmp = max(tmp, max_vert_suf[j + 1]);
            }
            ans = max(ans, l + max(max_not_incl, tmp));
        }
    }

    for (int i = 0; i < n; ++i) {
        int max_not_incl = 0;
        int l = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (!table[i][j]) {
                max_not_incl = 0;
                l = 0;
                continue;
            }
            max_not_incl = max(max_not_incl, max_vert_not_incl[i][j]);
            l += 1;
            int tmp = 0;
            if (j + l < m) {
                tmp = max(tmp, max_vert_suf[j + l]);
            }
            if (j >= 1) {
                tmp = max(tmp, max_vert_pref[j - 1]);
            }
            ans = max(ans, l + max(max_not_incl, tmp));
        }
    }

    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int k = 0; k < t; k++) {
        int n, m;
        cin >> n >> m;
        vector<vector<bool>> table(n, vector<bool>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char c;
                cin >> c;
                table[i][j] = (c == '.');
            }
        }
        cout << solve(n, m, table) << endl;
    }
    return 0;
}
