#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, k;
    cin >> n >> k;
    vector<long long> d(n);
    for (auto &i: d) {
        cin >> i;
    }
    sort(d.begin(), d.end());
    vector<long long> free(k, 0);
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int pos = -1;
        for (int j = 0; j < k; j++) {
            if (pos == -1 || free[j] < free[pos]) {
                pos = j;
            }
        }
        ans += free[pos] + d[i];
        free[pos] += d[i];
    }
    cout << ans << '\n';
}
