#include <random>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <string>
#include <fstream>
#include <map>
#include <ctime>

using namespace std;
using u64 = unsigned long long;

mt19937_64 rnd(42);

void accept(double& x, const string& s) {
    if (s == "sin") {
        x = sin(x);
    }
    else if (s == "cos") {
        x = cos(x);
    }
    else if (s == "tan") {
        x = tan(x);
    }
    else if (s == "asin") {
        x = asin(x);
    }
    else if (s == "acos") {
        x = acos(x);
    }
    else if (s == "atan") {
        x = atan(x);
    }
}

map<int, string> foo = {
        {0, "sin"},
        {1, "cos"},
        {2, "tan"},
        {3, "asin"},
        {4, "acos"},
        {5, "atan"},
};

int n = 30;

string solve(int a, int b) {
    double kek = double(a) / b;

    vector<string> s;

    auto f = [&]() {
        double x = 0;
        double best = 1e18;
        for (int i = 0; i < n; i++) {
            accept(x, s[i]);
            best = min(best, abs(x - kek));
        }
        return best;
    };

    while (true) {

        s.clear();
        for (int i = 0; i < n; i++) {
            s.push_back(foo[rnd() % 6]);
        }

        //cout << f() << "->";

        bool run = true;
        while (run) {
            run = false;

            for (int i = 0; i < n; i++) {
                for (int a = 0; a < 6; a++) {
                    double old = f();
                    string save = s[i];
                    s[i] = foo[a];
                    double cur = f();
                    if (cur < old) {
                        run = true;
                        //cout << f() << "->";
                    }
                    else {
                        s[i] = save;
                    }
                }
            }
        }

        if (f() < 1e-9) {
            double x = 0;
            string str;
            for (int i = 0; i < n; i++) {
                accept(x, s[i]);
                str += s[i] + ' ';
                if (abs(x - kek) < 1e-9) {
                    return str;
                }
            }
        }
        //cout << endl;
    }
    return "FUCK!";
}

int main() {
    //auto time = clock();

    //ofstream output("ans.txt");

    int a = 1, b = 2;
    cin >> a >> b;

    string s = solve(a, b);
    int cnt = 0;
    for (char c : s) {
        cnt += c == ' ';
    }
    cout << cnt << endl << s << endl;

    return 0;
}
