#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int main() {
    long long const M = 998244353;
    int n;
    cin >> n;
    vector<vector<int> > table(n+2);
    for(int j = 0; j < n+2; j++)
        table[0].push_back(-1);
    for(int j = 0; j < n+2; j++)
        table[n+1].push_back(-1);
    for(int i = 1; i <= n; i++) {
        string s;
        cin >> s;
        table[i].push_back(-1);
        for(int j = 0; j < n; j++) {
            if(s[j] == '.')
                table[i].push_back(-1);
            else if(s[j] == '#')
                table[i].push_back(1);
            else
                table[i].push_back(0);
        }
        table[i].push_back(-1);
    }
    long long count = 1;
    for(int i = 1; i < n+1; i++) {
        int left, right;
        left = 0;
        right = 1;
        while(right < n + 2) {
            int check = 0;
            if(table[i][left] == 1)
                check++;
            while (table[i][right] == 0 && right < n + 2) {
                right++;
            }
            if(right - left > 1) {
                if (table[i][right] == 1)
                    check++;
                if (check == 2)
                    count = 0;
                else if (check == 0)
                    count = (count * (right - left)) % M;
            }
            left = right;
            right++;
        }
    }
    for(int i = 1; i < n+1; i++) {
        int left, right;
        left = 0;
        right = 1;
        while(right < n + 2) {
            int check = 0;
            if(table[left][i] == 1)
                check++;
            while (table[right][i] == 0 && right < n + 2) {
                right++;
            }
            if(right - left > 1) {
                if (table[right][i] == 1)
                    check++;
                if (check == 2)
                    count = 0;
                else if (check == 0)
                    count = (count * (right - left)) % M;
            }
            left = right;
            right++;
        }
    }
    cout << count;
    return 0;
}

/*
 2
 .?
 ?#
 */
