#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


int index_min(vector<int>& vl) {
	int min = vl[0];
	int index = 0;
	for (int i = 1; i < vl.size(); i++) {
		if (vl[i] < min) {
			min = vl[i];
			index = i;
		}
	}
	return index;
}
int index_val(vector<int>& vl,int value,int start) {
	for (int i = start; i < vl.size(); i++) {
		if (vl[i] == value) {
			return i;
		}
	}
	return -1;
}
bool swap_big(vector<int>& vl, int first, int end) {
	for (int i = end; i > first; i--) {
		if (vl[i] - vl[i - 1] >= 2) {
			swap(vl[i], vl[i - 1]);
		}
		else {
			return false;
		}
	}
	return true;
}
int main()
{
	int n;
	cin >> n;
	vector<int> input(n);
	vector<int> output(n);
	for (int& vl : input) {
		cin >> vl;
	}
	for (int& vl : output) {
		cin >> vl;
	}
	vector<int> vl;
	for (int i = 0; i < n; i++) {
		int index = index_val(input, output[i],i);
		if (index == -1) {
			cout << -1 << endl;
			return 0;
		}
		if (!swap_big(input, i, index)) {
			cout << -1 << endl;
			return 0;
		}
		for (int j = index; j > i; j--) {
			vl.push_back(j);
		}
	}
	cout << vl.size() << endl;
	for (int i = 0; i < vl.size(); i++) {
		cout << vl[i] << " ";
	}
	cout << endl;
	return 0;


}
