#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long euclid(long x, long y)
{
	long ret = x * y;
	if (x > y)
		swap(x, y);

	while (y)
	{
		x %= y;
		if (y > x)
			swap(x, y);
	}
	return ret / x;
}

long task(long x, long y)
{
	long ret = x * y;
	//if (x > y)
	//	swap(x, y);

	while (y > 0)
	{
		x /= y;
			swap(x, y);
	}
	return ret / x;
}

int main()
{
	long n, q;
	vector<pair<long, long>> pi;
	cin >> n >> q;
	for (int i = 2; i < n + 1; ++i)
	{
		for (int j = 2; j < i+1; ++j)
		{
			if (euclid(i, j) == task(i, j))
				pi.push_back(make_pair(i, j));
		}
	}

	for (int i = 0; i < q; ++i)
	{
		cin >> n;
		if (pi.size() >= n)
			cout << pi[n - 1].first << " " << pi[n - 1].second << endl;
		else cout << -1 << " " << -1 << endl;
	}
}