
countCases = int(input())


def placeBrick(bricks, x, y, vertically):
    if vertically:

        total = 0

        while True:
            if len(bricks) == y:
                break

            if bricks[y][x] == "#":
                break
            else:
                total += 1
                bricks[y][x] = "#"
                y += 1

        return [bricks, total]
    else:
        total = 0

        while True:
            if len(bricks[y]) == x:
                break

            if bricks[y][x] == "#":
                break
            else:
                total += 1
                bricks[y][x] = "#"
                x += 1

        return [bricks, total]

def getResults(bricks):
    allResults = []

    for y in range(len(bricks)):
        for x in range(len(bricks[y])):
            placeVer = placeBrick(getCopy(bricks), x, y, False)
            placeHor = placeBrick(getCopy(bricks), x, y, True)

            if placeHor[1] > placeVer[1]:
                allResults.append((placeHor[1]))
            else:
                allResults.append((placeVer[1]))

    return max(allResults)

def getCopy(arr):
    arry = []

    for i in range(len(arr)):
        arry.append([])
        for g in range(len(arr[i])):
            arry[i].append(arr[i][g])

    return arry


def buildBricks():
    height, width = input().split(' ')
    height, width = int(height), int(width)

    bricks = []

    for i in range(height):
        bricks.append(list(input()[:width]))

    allResults = []

    for y in range(len(bricks)):
        for x in range(len(bricks[y])):

            placeVer = placeBrick(getCopy(bricks), x, y, False)
            placeHor = placeBrick(getCopy(bricks), x, y, True)

            ver = getResults(placeVer[0])
            hor = getResults(placeHor[0])

            if ver + placeVer[1] > hor + placeHor[1]:
                allResults.append(ver + placeVer[1])
            else:
                allResults.append(hor + placeHor[1])

    return max(allResults)

results = []

for i in range(countCases):
    results.append(buildBricks())

for i in results:
    print(i)