#include <bits/stdc++.h>

using ll = long long;

using namespace std;

int solve(vector<string> a) {
	int n = int(a.size());
	int m = int(a[0].size());
	int ans = 0;
	int bmax = 0;
	int bmax2 = 0;

	vector lens(n, vector<int>(m));
	multiset<int> st;
	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; ) {
			if (a[i][j] == '#') {
				++i;
				continue;
			}
			int k = i;
			while (k < n && a[k][j] == '.') ++k;
			st.insert(k - i);
			for (int t = i; t < k; ++t) {
				lens[t][j] = k - i;
			}
			i = k;
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ) {
			if (a[i][j] == '#') {
				++j;
				continue;
			}
			int k = j;
			while (k < m && a[i][k] == '.') ++k;
			int len = k - j;
			if (len > bmax) {
				bmax2 = bmax;
				bmax = len;
			} else {
				bmax2 = max(bmax2, len);
			}

			for (int t = j; t < k; ++t) {
				st.erase(st.find(lens[i][t]));
			}
			if (!st.empty()) {
				ans = max(ans, len + *st.begin());
			}
			for (int t = j; t < k; ++t) {
				st.insert(lens[i][t]);
				int up = 0;
				while (i - up - 1 >= 0 && a[i - up - 1][t] == '.') ++up;
				ans = max(ans, len + up);
				int down = 0;
				while (i + down + 1 < n && a[i + down + 1][t] == '.') ++down;
				ans = max(ans, len + down);
			}

			j = k;
		}
	}
	return max(ans, bmax + bmax2);
}

void solveTest() {
	int n, m;
	cin >> n >> m;
	vector<string> a(n);
	for (auto& s : a) cin >> s;

	int ans = 0;
	ans = max(ans, solve(a));
	vector<string> na(m, string(n, '.'));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			na[j][i] = a[i][j];
		}
	}
	ans = max(ans, solve(na));

	cout << ans << '\n';
}

int main(void) {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t; cin >> t; while (t--) solveTest();

	return 0;
}