#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> v(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            v[i][j] = s[j] == '#';
        }
    }
    int ans = 0;

    vector<int> verUp(n);
    for (int j = 0; j < m; j++) {
        int len = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == 1) {
                len = 0;
            } else {
                len++;
            }
            verUp[i] = max(verUp[i], len);
        }
    }
    for (int i = 1; i < n; i++) {
        verUp[i] = max(verUp[i], verUp[i - 1]);
    }

    vector<int> verDown(n);
    for (int j = 0; j < m; j++) {
        int len = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (v[i][j] == 1) {
                len = 0;
            } else {
                len++;
            }
            verDown[i] = max(verDown[i], len);
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        verDown[i] = max(verDown[i], verDown[i + 1]);
    }

    vector<int> horUp(m);
    for (int i = 0; i < n; i++) {
        int len = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == 1) {
                len = 0;
            } else {
                len++;
            }
            horUp[j] = max(horUp[j], len);
        }
    }
    for (int j = 1; j < m; j++) {
        horUp[j] = max(horUp[j], horUp[j - 1]);
    }

    vector<int> horDown(m);
    for (int i = 0; i < n; i++) {
        int len = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (v[i][j] == 1) {
                len = 0;
            } else {
                len++;
            }
            horDown[j] = max(horDown[j], len);
        }
    }
    for (int j = m - 2; j >= 0; j--) {
        horDown[j] = max(horDown[j], horDown[j + 1]);
    }

    vector<int> vars1;
    for (int i = 0; i < n; i++) {
        int len = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == 1) {
                vars1.push_back(len);
                len = 0;
            } else {
                len++;
            }
            ans = max(ans, len + (i ? verUp[i - 1] : 0));
            ans = max(ans, len + (i != n - 1 ? verDown[i + 1] : 0));
        }
        vars1.push_back(len);
    }
    sort(vars1.rbegin(), vars1.rend());
    if (vars1.size() == 0) {

    } else if (vars1.size() == 1) {
        ans = max(ans, vars1[0]);
    } else {
        ans = max(ans, vars1[0] + vars1[1]);
    }
    vector<int> vars2;
    for (int j = 0; j < m; j++) {
        int len = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == 1) {
                vars2.push_back(len);
                len = 0;
            } else {
                len++;
            }
            ans = max(ans, len + (j ? horUp[j - 1] : 0));
            ans = max(ans, len + (j != m - 1 ? horDown[j + 1] : 0));
        }
        vars2.push_back(len);
    }
    sort(vars2.rbegin(), vars2.rend());

    if (vars2.size() == 0) {

    } else if (vars2.size() == 1) {
        ans = max(ans, vars2[0]);
    } else {
        ans = max(ans, vars2[0] + vars2[1]);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
