#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;

string gen_sqrt(int x) {
	if (x == 1) {
		return "cos";
	}
	string ret = "cos atan sin";
	for (int i = 0; i < x - 2; ++i) {
		ret += " atan";
	}
	return ret;
}

string gen(int x) {
	if (x == 1) {
		return "cos";
	}
	return gen_sqrt(x * x + 1) + " acos tan";
}

int sqrtup(int x) {
	for (int i = 0;;++i) {
		if (i * i >= x) {
			return i;
		}
	}
}

string ans(int a, int b) {
	string ret;
	if (((b * b) % (a * a)) == 1) {
		ret = gen(a);
	}
	else {
		ret = ans(sqrtup((b * b) % (a * a)), a);
	}
	for (int i = 0; i < (b * b) / (a * a); ++i) {
		ret += " atan";
	}
	return ret;
}

int gcd(int x, int y) {
	while (y > 0) {
		x = x % y;
		swap(x, y);
	}
	return x;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	int a1, b1;
	cin >> a1 >> b1;
	int a = a1 / gcd(a1, b1);
	int b = b1 / gcd(a1, b1);
	if (a == 1) {
		cout << gen_sqrt(b * b) << '\n';
	}
	else if (b == 1) {
		cout << gen(a) << '\n';
	}
	else if (a > b) {
		cout << ans(b, a) << " atan acos sin tan\n";
	}
	else {
		cout << ans(a, b) << '\n';
	}
	return 0;
}