#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define Size(a) (int)a.size()
#define ll long long
#define ld long double

// #define int long long

using namespace std;

int get(const vector<string> &a) {
	int n = Size(a);
	int m = Size(a[0]);
	int mx1 = 0, mx2 = 0;
	// cerr << "1\n";
	for (int i = 0; i < n; i++) {
		for (int l = 0; l < m; ) {
			if (a[i][l] == '#') {
				l++;
				continue;
			}
			int r = l + 1;
			while (r < m && a[i][r] == '.')
				r++;
			int len = r - l;
			l = r;
			if (len > mx1) {
				mx2 = mx1;
				mx1 = len;
			} else if (len > mx2) {
				mx2 = len;
			}
		}
	}
	int ans = mx1 + mx2;
	// cerr << ans << "\n";

	vector<int> vert(m + 1, 0);
	for (int j = 0; j < m; j++) {
		for (int l = 0; l < n; ) {
			if (a[l][j] == '#') {
				l++;
				continue;
			}
			int r = l + 1;
			while (r < n && a[r][j] == '.')
				r++;
			vert[j] = max(vert[j], r - l);
			l = r;
		}
	}
	// cerr << ans << "\n";


	for (int i = 0; i < n; i++) {
		// cerr << i << endl;
		for (int j = 0; j < m; ) {
			if (a[i][j] == '#' || !(j == 0 || a[i][j - 1] == '#')) {
				j++;
				continue;
			}
			// cerr << j << " " << (int)a[i][j] << endl;
			int cur = 0;
			while (j < m && a[i][j] == '.') {
				cur++;
				int val = cur + vert[j + 1];
				// if (val == 7) {
				// 	cerr << i << " " << j << endl;
				// }
				ans = max(ans, val);
				j++;
			}
		}
	}
	// cerr << ans << "\n";

	vector<int> suf_max(m + 1);
	suf_max[m] = vert[m];
	for (int i = m - 1; i >= 0; i--)
		suf_max[i] = max(suf_max[i + 1], vert[i]);
	for (int i = 0; i < n; i++) {
		for (int l = 0; l < m; ) {
			if (a[i][l] == '#') {
				l++;
				continue;
			}
			int r = l + 1;
			while (r < m && a[i][r] == '.')
				r++;
			int val = r - l + suf_max[r];
			ans = max(ans, val);
			l = r;
		}
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> a(n);
	for (string &i : a)
		cin >> i;

	int ans = 0;
	for (int t = 0; t < 4; t++) {
		// cerr << t << endl;
		ans = max(ans, get(a));
		vector<string> b(m, string(n, '#'));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				b[m - j - 1][i] = a[i][j];
			}
		}
		a.swap(b);
		swap(n, m);
	}
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	#ifdef DIMSS
		freopen("test.txt", "r", stdin);
	#endif

	int T = 1;
	cin >> T;
	while (T--) {
		solve();
		#ifdef DIMSS
			cerr << "--------\n";
		#endif
	}

	return 0;
}
