#include <bits/stdc++.h>


using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).end()

using ll = long long;

mt19937_64 rng(239 + 30 + 179 + 57 + 123 + 366);

long long myRand(unsigned long long B) {
    return (unsigned long long)rng() % B;
}

template<class T>
using pair2 = pair<T, T>;

using pii = pair2<int>;
using pll = pair2<ll>;


template<class T>
T ckmin(T& a, T b) {
	return a < b ? a : a = b;
}

template<class T>
T ckmax(T& a, T b) {
	return a > b ? a : a = b;
}

template<class T, class U>
T ckmin(T& a, U b) {
	return a < b ? a : a = b;
}

template<class T, class U>
T ckmax(T& a, U b) {
	return a > b ? a : a = b;
}

template<class T>
istream& operator >>(istream& in, std::vector<T>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

template<class T>
ostream& operator <<(ostream& out, std::vector<T>& a) {
	for (auto i : a) {
		out << i << ' ';
	}
	return out;
}

template<class T>
void remDup(vector<T>& a) {
	sort(all(a));
	a.resize(unique(all(a)) - a.begin());
}


long double oper1(long double x) {
    return sin(x);
}

long double oper2(long double x) {
    return cos(x);
}

long double oper3(long double x) {
    return tan(x);
}

long double oper4(long double x) {
    return asin(x);
}

long double oper5(long double x) {
    return acos(x);
}

long double oper6(long double x) {
    return atan(x);
}

const long double eps = 1e-14;

void print_ans(vector<int>& a) {
    cout << a.size() << '\n';
    for (int i : a) {
        if (i == 0) {
            cout << "sin ";
        }
        if (i == 1) {
            cout << "cos ";
        }
        if (i == 2) {
            cout << "tan ";
        }
        if (i == 3) {
            cout << "asin ";
        }
        if (i == 4) {
            cout << "acos ";
        }
        if (i == 5) {
            cout << "atan ";
        }
    }
    cout << '\n';
}

void solve(long double a, long double b) {
    long double x = 0;
    long double target = a / b;
    vector<int> comands;
    while(fabs(x - target) > eps) {
        int cur = rand() % 6;
        while((x > 1 && (cur == 4 || cur == 5))) {
            cur = rand() % 6;
        }
        comands.push_back(cur);
        if (cur == 0) {
            x = oper1(x);
        }
        if (cur == 1) {
            x = oper2(x);
        }
        if (cur == 2) {
            x = oper3(x);
        }
        if (cur == 3) {
            x = oper4(x);
        }
        if (cur == 4) {
            x = oper5(x);
        }
        if (cur == 5) {
            x = oper6(x);
        }
    }
    print_ans(comands);
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tt = 1;
    long double a, b; cin >> a >> b;
    solve(a, b);
//    for (int a = 1; a <= 10; ++a) {
//        for (int b = 1; b <= 10; ++b) {
//            solve(a, b);
//        }
//    }

}