//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define sz(x) (x).size()
#define add push_back
#define all(x) (x).begin(), (x).end()

const ll MOD = 998'244'353;
const int N = 1010;
char f[N][N];

ll calc_str(int n) {
    ll ans = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (f[i][j] != '?') {
                continue;
            }
            int k = j;
            while (k < n && f[i][k + 1] == '?') {
                k++;
            }
            if (f[i][j - 1] == '#' && f[i][k + 1] == '#') {
                ans = 0;
            }
            if (f[i][j - 1] == '.' && f[i][k + 1] == '.') {
                ans *= ((k - j + 1) + 1); ans %= MOD;
            }
            j = k;
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    memset(f, '.', sizeof(f));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> f[i][j];
        }
    }
    ll ans_r = calc_str(n);
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            swap(f[i][j], f[j][i]);
        }
    }
    ll ans_c = calc_str(n);
    cout << (ans_r * ans_c) % MOD;
}
