#include <bits/stdc++.h>
//#include "ext/pb_ds/assoc_container.hpp"
//#include "ext/pb_ds/tree_policy.hpp"

//using namespace __gnu_pbds;
using namespace std;

typedef double ld;

#define int long long
#define ALL(x) (x).begin(), (x).end()
//#define ordered_set tree<int, null_type, less, rb_tree_tag, tree_order_statistics_node_update>

const int mod = 998244353;

int solve(vector<vector<char>> c) {
    int n = c.size() - 2;
    int ans = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (c[i][j] == '?') {
                int len = 0, cnt = (c[i][j - 1] == '#' ? 1 : 0);
                while (j + len <= n && c[i][j + len] == '?') {
                    c[i][j + len] = '.';
                    len++;
                }
                if (c[i][j + len] == '#') {
                    cnt++;
                }
                if (cnt == 2) {
                    ans *= 0;
                } else if (cnt == 0) {
                    ans *= (len + 1);
                    ans %= mod;
                }
            }
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<vector<char>>
                    c1(n + 2, vector<char> (n + 2, '.')),
                    c2(n + 2, vector<char> (n + 2, '.'));

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> c1[i][j];
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            c2[i][j] = c1[j][i];
        }
    }

    cout << (solve(c1) * solve(c2)) % mod;

    return 0;
}