#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const int INF = INT_MAX;

void solve();

int main() {
    input();
    solve();
    return 0;
}

const int N = 107;

int n;
int a[N], b[N];

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i){
        cin >> b[i];
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i){
        int j = find(a, a + n, b[i]) - a;
        while (j > i){
            if (abs(a[j] - a[j - 1]) <= 1){
                cout << "-1\n";
                return;
            }
            swap(a[j], a[j - 1]);
            ans.push_back(j - 1);
            --j;
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans){
        cout << i + 1 << ' ';
    }
}

