
#include <iostream>
#include <vector>
using ll =long long;
#include <algorithm>
#include <set>
#include <map>
using namespace std;

int main() {

	ll mod = 998244353;

	vector<pair<int, int>> kek = { {0, 1}, {1, 0}, {0, -1}, {-1, 0} };

	int n;
	cin >> n;
	vector<vector<int>> x(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			char c;
			cin >> c;
			if (c == '.')
				x[i][j] = -1;
			if (c == '#')
				x[i][j] = 1;
			if (c == '?')
				x[i][j] = 0;
		}
	}

	ll ans = 1;
	for (int i = 0; i < n; i++) {
		int j = 0;
		while (j < n && x[i][j] != 0) j++;
		
		int k = j - 1;
		int a = 0;
		if (j > 0 && x[i][k] == 1) a = 1;

		while (j < n && x[i][j] == 0)
			j++;
		
		int b = 0;
		if (j < n && x[i][j] == 1) b = 1;

		if (a + b == 0 && j - k > 1) {
			ans *= 2;
			ans %= mod;
		}

		if (a + b == 2)
			ans = 0;
		
	}

	for (int j = 0; j < n; j++) {
		int i = 0;
		while (i < n && x[i][j] != 0) i++;

		int k = i - 1;
		int a = 0;
		if (i > 0 && x[k][j] == 1) a = 1;

		while (i < n && x[i][j] == 0)
			i++;	

		int b = 0;
		if (i < n && x[i][j] == 1) b = 1;

		if (a + b == 0 && i - k > 1) {
			ans *= 2;
			ans %= mod;
		}

		if (a + b == 2)
			ans = 0;

	}

	cout << ans << '\n';
}