#include<bits/stdc++.h>
using namespace std;
  
// #define LOCAL
#define MULTITEST
  
#define int long long
  
#ifdef LOCAL 
    #define debug(x) cerr << #x << " = " << x << endl;
    #define ddebug(x, y) cerr << #x << " = " << x << " , " << #y << " = " << y << endl;
#else
    #define debug(x);
    #define ddebug(x, y);
#endif
  
template<typename T>
istream& operator >> (istream &in, vector<T> &v){
    for(int i = 0; i < v.size(); i++)
        in >> v[i];
  
    return in;
}
  
template<typename T>
ostream& operator << (ostream &out, vector<T> &v){
    for(int i = 0; i < v.size(); i++)
        out << v[i] << " \n"[i + 1 == v.size()];
  
    return out;
}
  
template<typename T, typename U>
ostream& operator << (ostream &out, vector<pair<T, U>> &v){
    for(int i = 0; i < v.size(); i++)
        out << v[i].first << ' ' << v[i].second << '\n';
  
    return out;
}
  
template<typename T, typename U>
istream& operator >> (istream &in, pair<T, U> &p){
    in >> p.first >> p.second;
    return in;
}
  
template<typename T, typename U>
ostream& operator << (ostream &out, pair<T, U> &p){
    out << p.first << ' ' << p.second;
    return out;
}
  
#define ll long long
#define ld long double
  
#define pii pair<int, int>
#define fi first
#define se second
 
#define ppii pair<pii, pii>
#define ff fi.fi
#define fs fi.se
#define sf se.fi
#define ss se.se
  
#define vi vector<int> 
#define vvi vector<vi>
#define pb push_back
  
#define vpii vector<pii>
#define vvpii vector<vpii>
#define vppii vector<ppii>
  
#define ALL(x) x.begin(), x.end()
  
const int INF32 = 2e9 + 5;
const ll INF64 = 4e9 + 5;   
  
const int mod = 1e9 + 7;
const ld eps = 1e-10;
  
const int sz = 20;
const int SZ = 1 << 20;
 
pii get_v(pii a, pii b){
    int x = a.fi - b.fi;
    int y = a.se - b.se;
    int GCD = __gcd(x, y);
    if (x < 0){
        x *= -1;
        y *= -1;
    }
    return {x / GCD, y / GCD};
}
 
struct Line{
    int A, B, C;
 
    Line(){ A = B = C = 0; }
 
    Line(pair<int, int> p, pair<int, int> q){
        A = p.second - q.second;
        B = q.first - p.first;
        C = p.first * q.second - p.second * q.first;
 
        if(A < 0){
            A = -A;
            B = -B;
            C = -C;
        }
 
        int g = __gcd(A, __gcd(B, C));
        A /= g;
        B /= g;
        C /= g;
    }
};
 
int get_or(pair<pair<int, int>, pair<int, int>> &otr, pair<int, int> &p){ // otr -- отрезок, p -- точка
    Line l = Line(otr.first, otr.second);
    int res = (p.first * l.A + p.second * l.B + l.C);
    return (res < 0 ? -1 : (res == 0 ? 0 : 1));
}
 
int _b = 2e6;
int _B = _b * _b;
 
int get_h(Line l){
    return l.A + l.B * _b + l.C * _B;
}
 
 
void Solve(){
  
    int n;
    cin >> n;
 
    vppii r(n);
    cin >> r;
 
    map<pii, int> mp;
    for (int i = 0; i < n; i++){
        mp[r[i].fi] = 0;
        mp[r[i].se] = 0;
    }
 
    int __ = 0;
    for (auto &e : mp){
        e.se = __++;
    }
 
    vpii to(n);
    for (int i = 0; i < n; i++){
        to[i].fi = mp[r[i].fi];
        to[i].se = mp[r[i].se];
    }
 
    vi h(n);
    for (int i = 0; i < n; i++){
        h[i] = get_h(Line(r[i].fi, r[i].se));
    }
 
    int ans = 0;
 
    // cout << r[0];
 
    // return;
 
    for (int i = 0; i < n; i++){
         
        vector<unordered_map<int, int>> arr[2];
        vi sum[2];
 
        arr[0].resize(2*n);
        arr[1].resize(2*n);
        sum[0].resize(2*n);
        sum[1].resize(2*n);
 
        for (int j = 0; j < n; j++){
 
            int st1 = get_or(r[i], r[j].fi);
            int st2 = get_or(r[i], r[j].se);
 
            if (st1 && st2 || !st1 && !st2){
                continue;
            }
 
            pii p = r[j].fi;
            pii q = r[j].se;
            if (st1){
                swap(p, q);
                swap(st1, st2);
            }
 
            // ddebug(i, j)
            // ddebug(min(r[i].fi.fi, r[i].se.fi), max(r[i].fi.fi, r[i].se.fi))
            // ddebug(min(r[i].fi.se, r[i].se.se), max(r[i].fi.se, r[i].se.se))
            if ((min(r[i].fi.fi, r[i].se.fi) > p.fi || p.fi > max(r[i].fi.fi, r[i].se.fi) || 
                 min(r[i].fi.se, r[i].se.se) > p.se || p.se > max(r[i].fi.se, r[i].se.se)) ||
                 r[i].fi == p || r[i].se == p
                ){
                continue;
            }
 
            // ddebug(i, j)
 
            arr[(st2 + 1) / 2][mp[p]][h[j]]++;
            sum[(st2 + 1) / 2][mp[p]]++;
 
        }
 
        for (int i = 0; i < 2; i++){
            for (int j = 0; j < 2*n; j++){
                int all = sum[i][j];
                for (auto x : arr[i][j]){
                    ans += (all - x.se) * x.se;
                }
            }
        }
    }
 
    cout << ans / 2;
 
}
  
signed main(){
  
    srand(time(NULL));
    cout << fixed << setprecision(10);
  
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(NULL);
        cin.tie(NULL);
        cout.tie(NULL);
    #endif
  
    int test_cnt = 1;
    #ifdef MULTITEST
        cin >> test_cnt;
    #endif
      
    for(int i = 1; i <= test_cnt; i++){
        Solve();
        cout << '\n';
    }
}