#include<bits/stdc++.h>

using namespace std;

template<typename T>
istream& operator >> (istream &in, vector<T> &v){
	for(int i = 0; i < v.size(); i++)
		in >> v[i];

	return in;
}

template<typename T>
ostream& operator << (ostream &out, vector<T> &v){
	for(int i = 0; i < v.size(); i++)
		out << v[i] << " \n"[i + 1 == v.size()];

	return out;
}

template<typename T, typename U>
ostream& operator << (ostream &out, vector<pair<T, U>> &v){
	for(int i = 0; i < v.size(); i++)
		out << v[i].first << ' ' << v[i].second << '\n';

	return out;
}

template<typename T, typename U>
istream& operator >> (istream &in, pair<T, U> &p){
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename U>
ostream& operator << (ostream &out, pair<T, U> &p){
	out << p.first << ' ' << p.second;
	return out;
}

void Solve(){
	int n; cin >> n;
	vector<int> a(n), b(n);
	cin >> a >> b;
	
	map<int, int> mp;

	for(int i = 0; i < n; i++)
		mp[b[i]] = i;

	vector<int> ans = {};

	for(int i = 0; i < n; i++){
		int j = i;

		while(j > 0 && mp[a[j]] < mp[a[j - 1]]){
			if(abs(a[j] - a[j - 1]) < 2)
				break;

			swap(a[j], a[j - 1]);
			ans.push_back(j);
			j--;
		}
	}

	if(a == b){
		cout << ans.size() << '\n';
		cout << ans;
	}else{
		cout << "-1\n";
	}
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "r", stdin);

	int test_cnt = 1;
	// cin >> test_cnt;

	for(int i = 1; i <= test_cnt; i++){
		Solve();
	}
}