#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
#define double long double

const ll MOD = 998244353;
const int INF = 1e9;

mt19937 rnd(0);

struct node {
    node *l, *r;
    int x, y, mn, val, sz = 0;

    node(int i, int val_) {
        l = r = nullptr;
        x = i, y = rnd(), mn = val_, val = val_;
    }
};

int min(node *root) {
    if (!root) return INF;
    return root->mn;
}

void up(node *root) {
    root->mn = min(root->val, min(min(root->l), min(root->r)));
//    root->sz = sz(root->l) + 1 + sz(root->r);
}

node *merge(node *a, node *b) {
    if (!a)return b;
    if (!b) return a;
    if (a->y < b->y) {
        a->r = merge(a->r, b);
        up(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        up(b);
        return b;
    }
}

pair<node *, node *> split(node *root, int i) {
    if (!root) return {nullptr, nullptr};
    if (root->x <= i) {
        auto p = split(root->r, i);
        root->r = p.first;
        up(root);
        return {root, p.second};
    } else {
        auto p = split(root->l, i);
        root->l = p.second;
        up(root);
        return {p.first, root};
    }
}

int ask(node *root, int k) {
    if (root == nullptr) return INF;
    int t = INF;
    if (root->val <= k) {
        t = root->x;
    }
    if (min(root->l) <= k) {
        return min(t, ask(root->l, k));
    } else {
        return min(t, ask(root->r, k));
    }
}

node *upd(node *root, int i, int c) {
    if (root->x == i) {
        root->val += c;
        up(root);
        return root;
    }
    if (root->x < i) {
        upd(root->r, i, c);
        up(root);
    } else {
        upd(root->l, i, c);
        up(root);
    }
    return root;
}

void print(node *root) {
    if (root == nullptr) return;
    print(root->l);
    cout << "{" << root->val << " " << root->mn << "} ";
    print(root->r);
}

int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    int a,b;
    cin>>a>>b;
    if(a==b){
        cout<<1<<'\n';
        cout<<"cos"<<'\n';
    }
    else{
        double x;
        double eps=0.000001;
        double c=(double)a/b;
        vector<string>ans={};
        for(int i=0;i<500;i++){
            x=cos(atan(x));
            ans.push_back("atan");
            ans.push_back("cos");
            if(abs(x-c)<=eps && a<b)break;
            if(abs(tan(acos(x))-c)<=eps && a>b){
                ans.push_back("acos");
                ans.push_back("tan");
                break;
            }
        }
        cout<<ans.size()<<'\n';
        for(int i=0;i<ans.size();i++)cout<<ans[i]<<' ';
        cout<<'\n';
    }
}
/*
5
5 4 3 2 1
 */

