#include <bits/stdc++.h>

using namespace std;

int get(int x, const vector<int> &a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        if (a[i] == x) return i;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto&x:a) cin >> x;
    for (auto&x:b) cin >> x;
    vector<int> ans;
    for (int pos = 0; pos < n; ++pos) {
        int cur = b[pos];
        int in_a = get(cur, a); // get pos of cur in a
        for (int i = in_a; i > pos; --i) {
            if (abs(a[i] - a[i - 1]) < 2) {
                cout << -1;
                return;
            }
            swap(a[i], a[i - 1]);
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (auto i:ans) cout << i << ' ';
}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r", stdin);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
