#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN = 2000000;
int cnt[MAXN] = {}, m = 1, answer;
vector<int> tree;
int get_min(int v, int Tl, int Tr, int l, int r) {
    if (l > r) {
        return 1e18;
    }
    if (l == Tl && Tr == r) {
        return tree[v];
    }
    int Tm = Tl + ((Tr - Tl) >> 1);
    return min(get_min(v << 1, Tl, Tm, l, min(r, Tm)), get_min(v << 1 | 1, Tm + 1, Tr, max(l, Tm + 1), r));
}

void upd(int v, int val) {
    v += m;
    tree[v] += val;
    v >>= 1;
    while (v) {
       tree[v] = min(tree[v<<1], tree[v<<1|1]);
       v>>=1;
    }
}

void sol(int x) {
    upd(x, 1);
    int left = 0, right = m - 1, mid;
    while (left < right) {
        mid = ((left + right) >> 1) + 1;
        if (get_min(1, 0, m - 1, 0, mid) < tree[x + m]) {
            right = mid - 1;
        } else {
            left = mid;
        } 
    }
    answer += max(0ll, right + 1 - x);
}

void sol2(int x) {
    if (tree[x + m] == 0) return;
    int left = 0, right = m - 1, mid;
    while (left < right) {
        mid = ((left + right) >> 1) + 1;
        if (get_min(1, 0, m - 1, 0, mid) < tree[x + m]) {
            right = mid - 1;
        } else {
            left = mid;
        } 
    }
    upd(x, -1);
    answer -= max(0ll, right + 1 - x);
}

void solve() {
    int n, q, p, x;
    cin >> n;
    while (m < MAXN) {
        m <<= 1;
    }
    tree.resize(m << 1, 0);
    int mins = 2e9;
    for (int i = 0; i < n; i++) {
        cin >> x;
        upd(i, x);
        mins = min(mins, x);
        answer += mins;
    }
    cout << answer << '\n';
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> p >> x;
        if (p == 1) {
            sol(x);
        } else {
            sol2(x);
        }
        cout << answer << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
