#include <bits/stdc++.h>
#define IOS ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#define vc vector
#define vi vector<int>
#define vll vector<long long>
#define forn(i,s,n) for(int i = (s); i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define f first
#define s second
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

const int INF = 2e9;
const ll INFL = 1e18;
const int PI = atan(1) * 4;
const int MXN = 1e6;
const int MOD = 1e9 + 7;

basic_istream<char> &operator>>(basic_istream<char> &in, vi &a) {
    forn(i, 0, a.size()) {
        in >> a[i];
    }
    return in;
}

basic_ostream<char> &operator<<(basic_ostream<char> &out, vi &a) {
    forn(i, 0, a.size()) {
        out << a[i] << ' ';
    }
    return out;
}

struct pt {
    int x, y;
    explicit pt(int x = 0, int y = 0) : x(x), y(y) {}
};

struct vec {
    int x, y;
    explicit vec(int x = 0, int y = 0): x(x), y(y) {}
    vec(pt a, pt b): x(b.x - a.x), y(b.y - a.y) {}
    ld len() {return sqrt(x * x + y * y);}
    ll dot(vec b) {return x * b.x + y * b.y;}
    vec cross(vec b) {return vec(x * b.y, -y * b.x);}
};

struct seg_tree {
    vi tree;
    seg_tree(vi &a) {
        tree.assign(4 * a.size(), 0);
        build(a, 0, 0, a.size());
    }
    void build(vi &a, int t, int l, int r) {
        if (l + 1 == r) {
            tree[t] = a[t];
            return;
        }
        int m = (l + r)/2;
        build(a, 2 * t + 1, l, m);
        build(a, 2 * t + 2, m, r);
        tree[t] = tree[2 * t + 1] + tree[2 * t + 2];
    }
    void upd(int t, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            tree[t] = val;
            return;
        }
        int m = (l + r)/2;
        if (pos < m) upd(2 * t + 1, l, m, pos, val);
        else upd(2 * t + 2, m, r, pos, val);
        tree[t] = tree[2 * t + 1] + tree[2 * t + 2];
    }
    int ask(int t, int l, int r, int x, int y) {
        if (y <= l || r <= x) return 0;
        if (x <= l && r <= y) return tree[t];
        int m = (l + r)/2;
        return ask(2 * t + 1, l, m, x, y) + ask(2 * t + 2, m, r, x, y);
    }
};

ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}

ll binPow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2) return a * binPow(a, n - 1);
    else {
        ll x = binPow(a, n/2);
        return x * x;
    }
}

int n;
vc<vi> dataKi;
vi ans(6);
// bottom left back front right top

bool dfs(int bottom, int top, int front, int back, int left, int right, int i, int j, int aBo, int aT, int aF, int aBa, int aL, int aR) {
    if (i == n - 1 && j == n - 1) {
        ans[aBo] = bottom;
        ans[aT] = top;
        ans[aF] = front;
        ans[aBa] = back;
        ans[aL] = left;
        ans[aR] = right;
        return true;
    }

    if (j < n - 1 && (right == -1 || right == dataKi[i][j + 1])) {
        right = dataKi[i][j + 1];
        if (dfs(right, left, front, back, bottom, top, i, j + 1, aR, aL, aF, aBa, aBo, aT)) {
            return true;
        }
    }
    if (i < n - 1 && (back == -1 || back == dataKi[i + 1][j])) {
        back = dataKi[i + 1][j];
        if (dfs(back, front, bottom, top, left, right, i + 1, j, aBa, aF, aBo,aT,aL,aR)) {
            return true;
        }
    }
    return false;
}

int main() {
    IOS;
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        dataKi.clear();
        dataKi.assign(n, vi(n, 0));
        ans.clear();
        ans.resize(6);
        forn(i, 0, n) {
            forn(j, 0, n) {
                int clr;
                cin >> clr;
                dataKi[i][j] = clr;
            }
        }
        // bottom left back front right top
        if (dfs(dataKi[0][0], -1, -1, -1, -1, -1, 0, 0, 0, 5, 3, 2, 1, 4)) {
            cout << "Yes\n";
            swap(ans[2], ans[3]);
            for (int el: ans) {
                if (el == -1) {
                    cout << 0;
                } else {
                    cout << el;
                }
                cout << ' ';
            }
            cout << '\n';
        } else {
            cout << "No\n";
        }
    }
}
/*
 4
 2
 1 1
 0 0
 3
 1 2 3
 9 6 4
 7 8 1
 4
 1 2 3 4
 9 8 7 5
 10 8 12 2
 13 14 15 6
 4
 1 2 3 4
 5 6 7 8
 9 10 11 12
 13 14 15 16
 */