#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define ll int64_t
#define pii pair < int, int >
#define pb push_back
#define int ll
#define f first
#define s second
#define ld long double

using namespace std;
using namespace __gnu_pbds;

//typedef tree < T, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;


int NMAX = 2e5;
const ll INF = 1e18 + 7;

vector < int > t(4 * NMAX, INF);
vector < int > a(NMAX);

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (tr < l || tl > r) {
        return INF;
    }
    if (tl >= l && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}

void upd(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] += val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        upd(v * 2, tl, tm, pos, val);
    } else {
        upd(v * 2 + 1, tm + 1, tr, pos, val);
    }
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    build(1, 0, n - 1);

//    for (int i = 0; i < n; i++) {
//        for (int j = i; j < n; j++) {
//            cout << get(1, 0, n - 1, i, j) << endl;
//        }
//    }
//    return 0;

    int k = a[0];
    int ans = k;

    for (int i = 1; i < n; i++) {
        k = min(k, a[i]);
        ans += k;
    }
    int res = 0;
    res = ans;
    cout << ans << endl;
    int qt;
    cin >> qt;
    while (qt--) {
        int type;
        cin >> type;
//        cerr << type << endl;
        if (type == 1) {
            int pos;
            cin >> pos;
            upd(1, 0, n - 1, pos, 1);
            a[pos]++;
            int mn = get(1, 0, n - 1, 0, pos);
            if (mn < a[pos]) {
//                cout << "!";
//                for (int i = 0; i < n; i++) {
//                    cout << a[i] << " ";
//                }
//                cout << endl;
                cout << res << endl;
                continue;
            }
//            cout << pos << " " << a[pos] << " " << mn << endl;
            int l = pos, r = n;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                int mn2 = get(1, 0, n - 1, 0, mid);
                if (mn2 == mn) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            int num = l;
            res += (num - pos + 1);
//            for (int i = 0; i < n; i++) {
//                cout << a[i] << " ";
//            }
//            cout << endl;
            cout << res << endl;
        } else {
            int pos;
            cin >> pos;
//            cerr << pos << endl;
            upd(1, 0, n - 1, pos, -1);
            a[pos]--;
            int mn;
            if (pos == 0) {
                mn = INF;
            } else {
                mn = get(1, 0, n - 1, 0, pos - 1);
            }
            if (mn <= a[pos]) {
//                for (int i = 0; i < n; i++) {
//                    cout << a[i] << " ";
//                }
//                cout << endl;
                cout << res << endl;
                continue;
            }
//            cerr << "?\n";
            mn = min(mn, a[pos]);
            int l = pos, r = n;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                int mn2 = get(1, 0, n - 1, pos + 1, mid);
                if (mn2 > mn) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            int num = l;
//            cout << endl;
//            cout << num << " " << a[num] << endl;
//            for (int i = 0; i < n; i++) {
//                cout << a[i] << " ";
//            }
//            cout << endl;
//            cout << endl;
            res += -(num - pos + 1);
//            for (int i = 0; i < n; i++) {
//                cout << a[i] << " ";
//            }
//            cout << endl;

            cout << res << endl;
        }
    }


    return 0;
}
