#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), where(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        b[i]--;
        where[b[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        if (where[a[i]] > i) {
            for (int j = i + 1; j < where[a[i]]; j++) {
                if (abs(b[j] - a[i]) < 2) {
                    cout << -1 << '\n';
                    return 0;
                }
            }
        } else if (where[a[i]] < i) {
            for (int j = i - 1; j > where[a[i]]; j--) {
                if (abs(b[j] - a[i]) < 2) {
                    cout << -1 << '\n';
                    return 0;
                }
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        int start = 0;
        while (a[start] != b[i]) {
            start++;
        }
        for (int j = start; j > i; j--) {
            swap(a[j], a[j - 1]);
            ans.push_back(j);
        }
    }
    cout << ans.size() << '\n';
    for (auto i: ans) {
        cout << i << " ";
    }
}