#include<iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<limits>
#include<cmath>
#include<fstream>
#include<iomanip>
#include<ctime>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>

using namespace std;

long long mod = 1e9 + 7;

long long gcd(long long a, long long b) {
	if (a < b){
		swap(a, b);
	}
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long bin_pow(long long a, long long b) {
	if (b == 0) {
		return 1;
	}
	if (b == 1) {
		return a % mod;
	}
	if (b % 2 == 0) {
		return (bin_pow((a * a) % mod, b / 2)) % mod;
	}
	return ((a % mod) * bin_pow(a, b - 1)) % mod;
}

vector<int> prefix_fun(string& s) {
	vector<int> p(s.size(), 0);
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) j = p[j];
		if (s[i] == s[j]) ++j;
		p[i] = j;
	}
	return move(p);
}

template<typename Type>
class segmentTree{
public:
	segmentTree(const vector<Type>& vec): data(vec.size()*4) {
		for (int i = data.size() - 1; i >= 0; --i) {
		}
	}

	vector<Type> data;
};

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	int n, k;
	cin >> n >> k;
	multiset<int> s;
	int ans = 0;
	vector<int> vec(n);
	for (int i = 0; i < n; ++i) {
		cin >> vec[i];
	}
	sort(vec.begin(), vec.end());
	vector<int> l(k);
	for (int i = 0; i < k; ++i) {
		s.insert(vec[i]);
		ans += vec[i];
	}
	for (int i = k; i < n; ++i)
	{
		int temp = *s.begin();
		s.erase(s.begin());
		ans += temp + vec[i];
		s.insert(temp + vec[i]);
	}
	cout << ans;
}
