#include "bits/stdc++.h"

using namespace std;
#define nn '\n'
typedef long long int ll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> source(n), target(n);
    unordered_map<int, int> current;
    for (int i = 0; i < n; i++) {
        cin >> source[i];
        current[source[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        cin >> target[i];
    }

    bool flag = false;
    vector<int> ans;

    for (int l = 0, r = n-1; l < r; ) {
        int x = target[l], i = current[x];
        while (i != l && abs(source[i]-source[i-1]) >= 2) {
            ans.push_back(i);
            swap(source[i], source[i-1]);
            current[x]--; current[source[i--]]++;
        }
        if (i != l) {
            flag = true;
            break;
        }
        l++;
        x = target[r], i = current[x];

        if (l >= r) break;

        while (i != r && abs(source[i]-source[i+1]) >= 2) {
            ans.push_back(i+1);
            swap(source[i], source[i+1]);
            current[x]++; current[source[i++]]--;
        }
        if (i != r) {
            flag = true;
            break;
        }
        r--;
    }

    if (flag || ans.size() > 20000) {
        cout << -1;
    } else {
        cout << ans.size() << nn;
        for (auto& elem : ans) cout << elem << ' ';
    }

}
